/* hst_dat -- memory allocation & data read
	minor amendment in read data   1019
*/

#include <stdlib.h>
#include <math.h>
#include "histo.h"

#define CNGX "** Due to negative data, log-normal analysis was discontinued! **\n"

extern char File[NF], Filet[NF], Filep[NF];
extern unsigned int Opt;
extern int N, Nfrq;
extern double *X, dX, Xmax, Xmin, Ymax, Ymin, *Frq, Mxl, Sxl, Mxg, Sxg;

void hst_dat(mx, sx, maxx, minx)
double *mx, *sx, *maxx, *minx;
{
	FILE *fp;
	char s1[30];
	int i, n, flagngx=0;
	double vxl, rangep, maxy, dmax1, dmax2, dum1, dum2, dum3;

	/* read data X[i] and calculate mean, stdev, ... */

	if ((fp=fopen(File,"r")) == NULL) error("Error of open file!");
	i = 0;
	while ((n=get_s(fp,1,s1)) != EOF){
		if (n==0 || s1[0]=='#' || s1[0]=='%') continue;
		i++;
	}
	N = i;
	X = mallocvd(N);   rewind(fp);
	i = 0;
	while ((n=get_s(fp,1,s1)) != EOF){
		if (n==0 || s1[0]=='#' || s1[0]=='%') continue;
		X[i] = atof(s1);
		if (X[i]<=0. && (Opt & LOGNORM_BIT) && flagngx==0){
			fprintf(stdout, CNGX);
			Opt &= ~LOGNORM_BIT;
			flagngx = 1;
		}
		i++;
	}
	if (i != N ) error("Miss count of data!");
	fclose(fp);
	meanvar(N, X, mx, &dum1, sx);
	maxmin(N, X, maxx, minx);
	if (Opt & LOGNORM_BIT){
		meanvarl(N, X, &Mxl, &vxl, &Sxl, &Mxg, &dum2);
		Sxg = sqrt(dum2);
	}

	/* determine X range & count frequency */

	if (!(Opt & XRANGE_BIT)){
		rangep = RANGEFACT*((*maxx) - (*minx));
		Xmax = (*maxx) + rangep;
		Xmin = (*minx) - rangep;
	}
	if (!(Opt & BIN_WIDTH_BIT)){
		dX = (Xmax - Xmin)/NBINDFLT;
		Nfrq = NBINDFLT;
	}
	else {
		Nfrq = ceil((Xmax - Xmin)/dX);
	}
	Frq = mallocvd(Nfrq);
	histd(N, X, Xmin, dX, Nfrq, Frq);

	/* determine Y range */

	if (!(Opt & YRANGE_BIT)){
		maxmin(Nfrq, Frq, &dmax1, &dum1);
		if (!(Opt & NORM_BIT) && !(Opt & LOGNORM_BIT))
			maxy = dmax1;
		else if ((Opt & NORM_BIT) && !(Opt & LOGNORM_BIT)){
			dmax2 = N*dX/(sqrt(DPAI)*(*sx));
			maxy = MAX(dmax1, dmax2);
		}
		else if (!(Opt & NORM_BIT) && (Opt & LOGNORM_BIT)){
			dmax2 = N*exp(vxl/2. - Mxl)*dX/(sqrt(DPAI)*Sxl);
			maxy = MAX(dmax1, dmax2);
		}
		else {
			dmax2 = N*dX/(sqrt(DPAI)*(*sx));
			dum2 = MAX(dmax1, dmax2);
			dmax2 = N*exp(vxl/2. - Mxl)*dX/(sqrt(DPAI)*Sxl);
			dum3 = MAX(dmax1, dmax2);
			maxy = MAX(dum2, dum3);
		}
		rangep = RANGEFACT*(maxy - Ymin);
		Ymax = maxy + rangep;
	}
}

/* hst_mfree */

void hst_mfree()
{
	freevd(X);   freevd(Frq);
}
#undef CNGX
