/* pcirc -- plots a circle fitted to x-y data using GMT 5. V1.0   1019
	for usage, options, and input files, see pcirc.h.
    Variables:
	N,X,Y -- number & array of data (X[0]--X[N-1],Y[0]--Y[N-1])
	X0,Y0,R -- center & radius of the fitted circle
	K,Sse -- measure of curvature & sum of squares of error of Paterson (2011)
	Er -- array of error given by Er=sqrt((X-X0)^2+(Y-Y0)^2)-R
	Th -- array of theta given by tan(Th)=(Y-Y0)/(X-X0)
	Xmin,Xmax,Ymin,Ymax -- ranges of X & Y axes to be plotted
*/

#include <stdlib.h>
#include "pcirc.h"

#define HEAD "Circle fitting of %s\n\
  PS file: %s\n\
   N     X0         Y0         R          k          SSE\n\
  %-3d %#- 10.4g %#- 10.4g %#- 10.4g %#- 10.4g %#- 10.4g\n"
#define HEAD2 "  Input data:\n    i   X          Y          Error\n"
#define CONT2 "   %2d %#- 10.4g %#- 10.4g %#- 10.4g\n"

char File[NF], Filet[NF], Filep[NF];
unsigned int Opt=0;
int N;
double *X, *Y, *Th, X0, Y0, R, K, *Er, Sse, Xmax, Xmin, Ymax, Ymin;

int main(argc, argv)
int argc;
char *argv[];
{
	int i;

	pcr_cmd(argc, argv);
	pcr_dat();
	fprintf(stdout, HEAD, File, Filep, N, X0, Y0, R, K, Sse);
	if (Opt & LISTDAT_BIT){
		fprintf(stdout, HEAD2);
		for (i=0; i<N; i++)
			fprintf(stdout, CONT2, i+1, X[i], Y[i], Er[i]);
	}
	pcr_fig();
	pcr_mfree();
/*	sys_call(3, "evince ", Filep, " &"); */
	sys_call(2, "rm -f ", Filet);
}
#undef HEAD
#undef HEAD2
#undef CONT2

