/* pcirc.h */

#include "std.h"

#define USAGE	"Usage: pcirc file [-Xmin/max -Ymin/max -C -A -L -H]"
#define HELP	"HELP MESSAGE OF PCIRC\n\
  Circle fitting of x-y data (N>=3) V1.01, H.Tanaka,2021,2019.\n\
\n\
Usage:\n\
  pcirc file [-Xmin/max -Ymin/max -C -A -L -H]\n\
\n\
Options:\n\
  -Xmin/max -- range of min and max for x-axis\n\
  -Ymin/max -- range of min and max for y-axis\n\
              (options X/Y alter only the graph appearance)\n\
  -C        -- plot the circle center\n\
  -A        -- plot the arc spanning the data range\n\
               (not draw the whole circumference)\n\
  -L        -- list the input data to stdout\n\
  -H        -- help message\n\
\n\
Input file:\n\
  # comment line with # (or %) at the beginning at any places\n\
  # paired x-y data per line (N>=3)\n\
  x1 y1 [z1, .. -- any extra data are ignored]\n\
  x2 y2\n\
   .\n\
   .\n\
\n\
Output file:\n\
  PS graph of fitted circle is created with the name \"file.ps\".\n\
(Press Q to Quit)"

#define NF	200
#define NBUF	250

#define XRANGE_BIT	1
#define YRANGE_BIT	2
#define CENTER_BIT	4
#define ARC_BIT		8
#define LISTDAT_BIT	16

#define RANGEFACT	0.1

#define MAPWIDTH	12.5
#define MAPHEIGHT	12.5
#define GSET	" PS_MEDIA A4 PROJ_LENGTH_UNIT c MAP_FRAME_TYPE plain MAP_FRAME_PEN thick,black \
MAP_TICK_PEN_PRIMARY thin,black MAP_GRID_PEN_PRIMARY thinner,black \
FONT_TITLE 18p,Helvetica-Bold,black FONT_LABEL 14p,Helvetica-Bold,black \
FONT_ANNOT_PRIMARY 12p,Helvetica,black MAP_POLAR_CAP none FORMAT_FLOAT_MAP %.4g \
FORMAT_TIME_STAMP \"%Y %b %d\""

/* functions */

void pcr_cmd();
void pcr_dat(), pcr_mfree();
void pcr_fig(), g_xmax_dx();
