/* pcr_cmd -- command interpretation for pcirc */

#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "pcirc.h"

#define HUGE 1.e+20

extern char File[NF], Filet[NF], Filep[NF];
extern unsigned int Opt;
extern double Xmax, Xmin, Ymax, Ymin;

void pcr_cmd(argc, argv)
int argc;
char *argv[];
{
	char *s, s1[20], s2[20], buf[NBUF], *ptr;
	int flagf=0;

	if (argc < 2) error(USAGE);
	while (--argc > 0){
	if (*argv[argc] == '-'){
		s = argv[argc] + 1;
		switch (toupper(*s)){
		case 'X':
			getoption(s+1, 2, s1, s2);
			if (s1[0]=='\0' || s2[0]=='\0') error("Assign min & max of X-range!");
			Xmin = atof(s1);   Xmax = atof(s2);
			if (Xmin<-HUGE || Xmax>HUGE || Xmin>=Xmax)
				error("Error in the range of X-axis!");
			Opt |= XRANGE_BIT;
			break;
		case 'Y':
			getoption(s+1, 2, s1, s2);
			if (s1[0]=='\0' || s2[0]=='\0') error("Assign min & max of Y-range!");
			Ymin = atof(s1);   Ymax = atof(s2);
			if (Ymin<-HUGE || Ymax>HUGE || Ymin>=Ymax)
				error("Error in the range of Y-axis!");
			Opt |= YRANGE_BIT;
			break;
		case 'C':
			Opt |= CENTER_BIT;
			break;
		case 'A':
			Opt |= ARC_BIT;
			break;
		case 'L':
			Opt |= LISTDAT_BIT;
			break;
		case 'H':
			showless(HELP);
			break;
		default:
			error("Unknown option!");
			break;
		}
	}
	else {
		strcpy(File, argv[argc]);
		flagf++;
	}
	}
	if (flagf == 0)
		error("Assign a data file!");
	else if (flagf > 1)
		error("Assign only one file!");
	strcpy(buf, File);
	if ((ptr=strtok(buf,".")) == NULL) error("Error of data file at strtok!");
	strcpy(Filet, ptr);   strcat(Filet, ".TMP");
	strcpy(Filep, ptr);   strcat(Filep, ".ps");
}
#undef HUGE
