/* pcr_dat -- memory allocation & data read */

#include <stdlib.h>
#include <math.h>
#include "pcirc.h"

extern char File[NF], Filet[NF], Filep[NF];
extern unsigned int Opt;
extern int N;
extern double *X, *Y, *Th, X0, Y0, R, K, *Er, Sse, Xmax, Xmin, Ymax, Ymin;

#define NMIN 3

void pcr_dat()
{
	FILE *fp;
	char s1[30], s2[30];
	int i, n;
	double xm, ym;

	/* read data X[i] & Y[i] and call circreg */

	if ((fp=fopen(File,"r")) == NULL) error("Error of open file!");
	i = 0;
	while ((n=get_s(fp,1,s1)) != EOF){
		if (n==0 || s1[0]=='#' || s1[0]=='%') continue;
		i++;
	}
	N = i;
	if (N < NMIN) error("Less than three data points!");
	X = mallocvd(N);  Y = mallocvd(N);
	Th = mallocvd(N);  Er = mallocvd(N);
	rewind(fp);
	i = 0;
	while ((n=get_s(fp,2,s1,s2)) != EOF){
		if (n==0 || s1[0]=='#' || s1[0]=='%') continue;
		X[i] = atof(s1);  Y[i] = atof(s2);
		i++;
	}
	if (i != N ) error("Miss count of data!");
	fclose(fp);
	circreg(N, X, Y, &X0, &Y0, &R, &xm, &ym, Er, &Sse);

	/* definition of k is extended from Paterson (2011) for general cases */

	if (X0==xm && Y0==ym) K = 0.;
	else if ((X0>xm && Y0>ym) || (X0<xm && Y0>ym)) K = 1./R;
	else if ((X0<xm && Y0<ym) || (X0>xm && Y0<ym)) K = -1./R;
	else {
		K = 1./R;
		fprintf(stderr, "** Strange circle center! **\n");
	}
}

/* pcr_mfree */

void pcr_mfree()
{
	freevd(X);  freevd(Y);  freevd(Th);  freevd(Er);
}
#undef NMIN
