/* pdemag.h -- header file for pdemag   082203 */

#include "std.h"

/* general definitions, etc. */

#define FILEP	"PDEMAG.PS"
#define FILET	"PDEMAG.TMP"

#define WFILE	100	/* maximum length of data file name */
#define WSAMP	50	/* maximum length of sample name */
#define WSTEP	50	/* maximum length of step id */
#define ZERO	0

/* data coordinate frames used by unsigned int Frame */

#define CORE	0
#define SITU	1
#define TILT	2

/* For options used by unsigned int Opt */

#define PLOT_CHI_BIT	1
#define STEP_BIT	2
#define NUMBER_BIT	4
#define ZJ_TOP_BIT	8
#define EQ_TOP_BIT	16
#define WRT_FILE_BIT	32
#define LINE_BIT	64
#define GTC_BIT		128
#define AUTO_BIT	256
#define ORIGIN_BIT	512
#define ANCHOR_BIT	1024
#define DRAW_BIT	2048

/* GMT plot sizes */

#define SMALL	0
#define MEDIUM	1
#define LARGE	2

/* other GMT options */

#define PEN2S	" -W0.25p,black"
#define PEN2D	" -W0.25p,black,2_2:0"
#define PEN2SG	" -W0.25p,132"
#define PEN2DG	" -W0.25p,132,2_2:0"
#define PEN3S	" -W0.5p,black"
#define PEN3D	" -W0.5p,black,2_2:0"
#define PEN3SG	" -W0.5p,132"
#define PEN3DG	" -W0.5p,132,2_2:0"
#define PEN5S	" -W1.0p,black"
#define PEN5D	" -W1.0p,black,5_5:0"
#define PEN5SG	" -W1.0p,132"
#define PEN5DG	" -W1.0p,132,5_5:0"

#define OPTF	" -F+f+j"

/* Type of functions */

void quit_gv();
FILE *pdmg_cmd();
int pdmg_comd(); void do_init(), go_next(), go_back(), go_first(), go_last(), core_orient(), \
	situ_orient(), bed_orient(), message_orient(), do_pcaline(), do_pcagtc(), set_pcaauto(), \
	set_pcaorigin(), critical_mad(), anchor_origin(), delete_results(), write_results(), \
	out_psfile(), enlarge_scale(), put_annot(), change_eq(), change_zj();
int pdmg_dat(); void count_step(), pdmg_mem1(), pdmg_mem2(), free_all();
void pdmg_eq(), set_gtc_circ();
void pdmg_gmtdat(), set_eqdata(), set_jndat(); double set_zjdata(), set_dX(); int set_chidat();
void pdmg_gtc(), situ_ctg(), core_stg(), tilt_csg(), pdmg_gtc_parm(), seek_g();
int pdmg_gtca();
void pdmg_jn(), pdmg_chi(), find_mdf();
void pdmg_line(), situ_coretilt(), core_situtilt(), tilt_coresitu(), set_zjpcaline();
int pdmg_linea();
void pdmg_plot(), wrt_tmp(), wrt_tmp2(), wrt_tmp3(), wrt_tmp3i();
int pdmg_smpldat();
void pdmg_zj(), draw_tickx(), draw_ticky();
