/* pdmg_gmtvars.h -- declare character variables in 3-d array for use in GMT command 
	should be called only once at the begining of the main program
*/

/* for general use */

char *Frame_lbl[] = {"CORE", "IN SITU", "BED TILTED"};

/* for use by both pdmg_zj() and pdmg_eq() */

char *Maptxt[] = {" -Jx1 -R0/5.0/0/5.0", " -Jx1 -R0/7.0/0/7.0", " -Jx1 -R0/12.0/0/12.0"};

/* for eaual area plot by pdmg_eq(), where [0],[1],[2] are SMALL, MEDIUM, LARGE */

char *Mapeq[] = {" -JA180/90/5.0", " -JA180/90/7.0", " -JA180/90/12.0"};
char *Texteq[] = {
"5.00  5.02 11p,Helvetica-Bold,black RB %s\n\
 2.50  5.02 12p,Helvetica,black CB 0\n\
 5.02  2.50 12p,Helvetica,black LM 90\n\
 2.50 -0.02 12p,Helvetica,black CT 180\n\
-0.02  2.50 12p,Helvetica,black RM 270\n",

"7.00  7.00 12p,Helvetica-Bold,black RB %s\n\
 3.50  7.02 12p,Helvetica,black CB 0\n\
 7.02  3.50 12p,Helvetica,black LM 90\n\
 3.50 -0.02 12p,Helvetica,black CT 180\n\
-0.02  3.50 12p,Helvetica,black RM 270\n",

"12.00  12.00 12p,Helvetica-Bold,black RB %s\n\
  6.00  12.02 12p,Helvetica,black CB 0\n\
 12.02   6.00 12p,Helvetica,black LM 90\n\
  6.00  -0.02 12p,Helvetica,black CT 180\n\
 -0.02   6.00 12p,Helvetica,black RM 270\n"};

/* for Zijderveld plot by pdmg_zj(), where [0], [1], [2] are SMALL, MEDIUM, LARGE */

char *Mapzj[] = {" -JX5.0/-5.0", " -JX7.0/-7.0", " -JX12.0/-12.0"};
char *Textzj[] = {"5.0 5.1 12p,Helvetica-Bold,black RB %s\n",
	"7.0 7.1 12p,Helvetica-Bold,black RB %s\n", "12.0 12.1 12p,Helvetica-Bold,black RB %s\n"};

/* controls, symbols, etc. for three sizes of the figure */

char *Cstep[] = {"%.4f %.4f 9p,Helvetica,black BL %.0f\n",
	"%.4f %.4f 10p,Helvetica,black BL %.0f\n", "%.4f %.4f 10p,Helvetica,black BL %.0f\n"};
char *Cstepg[] = {"%.4f %.4f 9p,Helvetica,132 BL %.0f\n",
	"%.4f %.4f 10p,Helvetica,132 BL %.0f\n", "%.4f %.4f 10p,Helvetica,132 BL %.0f\n"};
char *Cnumb[] = {"%.4f %.4f 9p,Helvetica,black BL %d\n",
	"%.4f %.4f 10p,Helvetica,black BL %d\n", "%.4f %.4f 10p,Helvetica,black BL %d\n"};
char *Cnumbg[] = {"%.4f %.4f 9p,Helvetica,132 BL %d\n",
	"%.4f %.4f 10p,Helvetica,132 BL %d\n", "%.4f %.4f 10p,Helvetica,132 BL %d\n"};

char *Circs[] = {" -Sc0.15c -G0 -W1.0p,black", " -Sc0.20c -G0 -W1.0p,black", " -Sc0.25c -G0 -W1.0p,black"};
char *Circsg[] = {" -Sc0.15c -G132 -W1.0p,132", " -Sc0.20c -G132 -W1.0p,132", " -Sc0.25c -G132 -W1.0p,132"};
char *Circo[] = {" -Sc0.15c -G255 -W1.0p,black", " -Sc0.20c -G255 -W1.0p,black", " -Sc0.25c -G255 -W1.0p,black"};
char *Circog[] = {" -Sc0.15c -G255 -W1.0p,132", " -Sc0.20c -G255 -W1.0p,132", " -Sc0.25c -G255 -W1.0p,132"};

char *Cross[] = {" -Sx0.15c -G0 -W1.0p,black", " -Sx0.20c -G0 -W1.0p,black", " -Sx0.25c -G0 -W1.0p,black"};
char *Crossd[] = {" -Sx0.15c -G0 -W1.0p,black,2_2:0", " -Sx0.20c -G0 -W1.0p,black,2_2:0", " -Sx0.25c -G0 -W1.0p,black,2_2:0"};

char *Dshift[] = {" -D0.1c/0.1c", " -D0.1c/0.1c", " -D0.15c/0.15c"};
