#include "pdemag.h"

#define GMTPRMS " PS_MEDIA A4 PROJ_LENGTH_UNIT c MAP_FRAME_TYPE plain MAP_FRAME_PEN 1p,black \
MAP_TICK_PEN_PRIMARY 0.5p,black MAP_GRID_PEN_PRIMARY 0.25p,black \
FONT_LABEL 12p,Helvetica-Bold,black FONT_ANNOT_PRIMARY 10p,Helvetica,black MAP_POLAR_CAP none \
FORMAT_TIME_STAMP \"%Y %b %d\""

extern char **Sampl, *Maptxt[], Sdum[LSIZ_COM];
extern unsigned int Opt, Frame;
extern FILE *Fpt;

/* pdmg_plot -- initialize GMT and plot diagrams of nth sample based on the setup by pdmg_gmtdat(), 
	and defines functions used to write a GMT temporary data file.
	UPDATE: wrt_tmp() was simplified to avoid problems in use with recent gcc.   031918
*/

void pdmg_plot(n)
int n;
{
	int frame0 = CORE, frame1 = SITU, frame2 = TILT;

	if (Frame == CORE){
		frame0 = TILT;   frame1 = CORE;   frame2 = SITU;
	}
	sys_call(2, "gmt set", GMTPRMS);
	pdmg_jn(" -X4.0 -Y2.0");
	if (Opt & PLOT_CHI_BIT)
		pdmg_chi(" -X9.0");
	else
		pdmg_eq(frame0, SMALL, " -X9.0");
	if ( !(Opt & EQ_TOP_BIT) ){
		pdmg_eq(frame1, MEDIUM, " -X-10.00 -Y6.00");
		pdmg_eq(frame2, MEDIUM, " -X9.00");
		pdmg_zj(Frame, LARGE, " -X-7.0 -Y8.0");
	}
	else {
		pdmg_zj(frame1, MEDIUM, " -X-10.00 -Y6.00");
		pdmg_zj(frame2, MEDIUM, " -X9.00");
		pdmg_eq(Frame, LARGE, " -X-7.0 -Y8.0");
	}
	sprintf(Sdum, "0.0 12.1 12p,Helvetica-Bold,black LB %s\n", Sampl[n]);
	wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, Maptxt[LARGE], OPTF, " -N -P -O >>", FILEP);
}

/* wrt_tmp -- Ver.2: write some parameters to GMT TMP file. First use sprintf() to write
	params into char s (extern char Sdum[LSIZ_COM]), then call this function.   031918
*/

void wrt_tmp()
{
	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file at wrt_tmp!");
	if (fprintf(Fpt, "%s", Sdum) <= 0)
		error("Error of fprintf at wrt_tmp!");
	fclose(Fpt);
}

/* wrt_tmp2 -- write two double arrays from i1 to i2 for use by psxy */

void wrt_tmp2(i1, i2, cont, d1, d2)
int i1, i2;
char *cont;
double *d1, *d2;
{
	int i;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	for (i = i1; i <= i2; i++){
		fprintf(Fpt, cont, d1[i], d2[i]);
	}
	fclose(Fpt);
}

/* wrt_tmp3 -- write three double arrays from i1 to i2 for use by pstext */

void wrt_tmp3(i1, i2, cont, d1, d2, d3)
int i1, i2;
char *cont;
double *d1, *d2, *d3;
{
	int i;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	for (i = i1; i <= i2; i++){
		fprintf(Fpt, cont, d1[i], d2[i], d3[i]);
	}
	fclose(Fpt);
}

/* wrt_tmp3i -- write two double arrays plus one int array for use by pstext */

void wrt_tmp3i(i1, i2, cont, d1, d2, int3)
int i1, i2, *int3;
char *cont;
double *d1, *d2;
{
	int i;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	for (i = i1; i <= i2; i++){
		fprintf(Fpt, cont, d1[i], d2[i], int3[i]);
	}
	fclose(Fpt);
}
#undef GMTPRMS
