/* pdirec -- Analysis of site paledirections by Fisher statistics including GTC
	GMT6.3 psxy warning to draw empty A95 was fixed (pdrc_fld,pdrc_vgp)   120624
	V.1.2: adapted to use GMT 5.2.1 & adopted commands common to other pmag progs  052618
	V.1.1: commands + & - (go 10 samples forward or backward) added.   110513
	V.1.0: For the details, see the HELP message in pdrc_cmd()         092603
*/

#define COMMAND "+,-,0,9,8,1,C,S,B,U,M,D,R,I,W,P,H,Q?"
#define HELPCMD "Commands:\n\
  \e[1m+\e[m-next, \e[1m-\e[m-back, \e[1m0\e[m-first, \e[1m9\e[m-last, \e[1m8\e[m-10next, \e[1m1\e[m-10back,\n\
  \e[1mC\e[more, in-\e[1mS\e[mitu, \e[1mB\e[med-corrected, so\e[1mU\e[mthern-hemi-on/off,\n\
  \e[1mM\e[mad-circle-on/off, \e[1mD\e[melete-one, \e[1mR\e[mestore-one, iteration-\e[1mI\e[mnitial,\n\
  \e[1mW\e[mrite-results, \e[1mP\e[msfile, \e[1mH\e[melp, \e[1mQ\e[muit"

#include <ctype.h>
#include "pdirec.h"

FILE *Fpt, *Fpw;
char *Frame_lbl[] = {"CORE", "IN SITU", "BED TILTED"};
char **Site, **Smpl, **Smplg, Filed[WFILE], Filew[WFILE], Buf[WBUF];
unsigned int Opt = 0, Frm = SITU;
int Nsite, Ns, Nsg, Nst, Nstg, *Idsmp, *Idsmpg, *Id, *Rjc, *Idg, *Rjcg;
double *Slt, *Sln, **Is, **Ds, **Ip, **Dp, **Ia1, **Da1, **Ia2, **Da2, *Mad, *Madg;
double *Xs, *Ys, *Zs, *Dlt, *Dltg, *Xp, *Yp, *Zp, *Ig, *Dg, *Vlt, *Vln, *Vltr, *Vlnr, \
	*Vltg, *Vlng, *Vltgr, *Vlngr, *Dltv, *Dltvg, Im, Dm, R, K, A95, Asd, \
	Vltm, Vlnm, Vltmr, Vlnmr, dP, dM, Asdv;
double *Ieq, *Deq, *Ieqr, *Ieqg, *Deqg, *Ieqgr, Imeq, Dmeq, Imeqr;

int main(argc, argv)
int argc;
char *argv[];
{
	FILE *fpr;
	int n = 0, c, nsmpl, nsmplg;

	if ((fpr = pdrc_cmd(argc, argv, Filed)) == NULL) error("Error in fopen!");
	pdrc_dat(fpr, &nsmpl, &nsmplg);
	fclose(fpr);
	fprintf(stdout, "Paleodirections from %s\n", Filed);
	pdrc_sitedat(n);
	fprintf(stdout, "%s (%s)\n", Site[n], Frame_lbl[Frm]);
	pdrc_plot(n);
	sys_call(3, "evince ", FILEP, " &");
/*	sys_call(3, "gv -nodsc -watch -scale=0.7 ", FILEP, " &"); */
/*	sys_call(3, "gv -nodsc -watch ", FILEP, " &"); */
/*	sys_call(3, "gv --nodsc --watch ", FILEP, " &"); */
	while ((c = pdrc_comd(COMMAND)) != ZERO){
		switch(toupper(c)){
		case '+':
			go_next(&n); break;
		case '-':
			go_back(&n); break;
		case '0':
			go_first(&n); break;
		case '9':
			go_last(&n); break;
		case '8':
			go_plus10(&n); break;
		case '1':
			go_minus10(&n); break;
		case 'C':
			core_orient(n); break;
		case 'S':
			situ_orient(n); break;
		case 'B':
			bed_orient(n); break;
		case 'U':
			change_south(n); break;
		case 'M':
			put_mad(n); break;
		case 'D':
			delete_one(n); break;
		case 'R':
			restor_one(n); break;
		case 'I':
			it_initial(n); break;
		case 'W':
			write_results(n); break;
		case 'P':
			out_psfile(n); break;
		case 'H':
			fprintf(stdout, "%s\n", HELPCMD); break;
		default:
			break;
		}
	}
/*	free_all(Nsite, nsmpl, nsmplg); Core dumped when used? */
	quit_gv();
	sys_call(2, "rm -f ", FILET);
}

/* quit_gv -- force to kill the running Ghost View */

void quit_gv()
{
	FILE *fp;
	char *file1 = "PDIREC.TM2", *file2 = "PDIREC.TM3", s1[20];

	sys_call(2, "ps a >", file1);
	sys_call(4, "grep \"evince\" ", file1, " >", file2);
/*	sys_call(4, "grep \"gv -nodsc -watch -scale=0.7\" ", file1, " >", file2); */
/*	sys_call(4, "grep \"gv -nodsc -watch\" ", file1, " >", file2); */
/*	sys_call(4, "grep \"gv --nodsc --watch\" ", file1, " >", file2); */
	if ((fp = fopen(file2, "r")) == NULL) error("Error at quit_gv!");
	get_s(fp, 1, s1);
	fclose(fp);
	sys_call(2, "kill ", s1);
	sys_call(2, "rm -f ", file1);   sys_call(2, "rm -f ", file2);
}
#undef COMMAND
#undef HELPCMD
