/* pdirec.h -- header file for pdirec */

#include "std.h"

/* general definitions, etc. */

#define FILEP	"PDIREC.PS"
#define FILET	"PDIREC.TMP"

#define WFILE	100	/* maximum length of data file name */
#define WSITE	50	/* maximum length of site name */
#define WSAMP	50	/* maximum length of sample name */
#define WBUF	1000	/* maximum length of Buf used by wrt_tmp */
#define NAMAX	64	/* maximum number of points to draw a95 */
#define ZERO	0

/* data coordinate frames used by unsigned int Frm */

#define CORE	0
#define SITU	1
#define TILT	2

/* For use by unsigned int Opt */

#define S_HEMI_BIT	1
#define ENBL_MAD_BIT	2
#define WRT_FILE_BIT	4
#define IT_INITIAL_BIT	8

/* GMT options */

#define PEN2S   " -W0.25p,black"
#define PEN2D   " -W0.25p,black,2_2:0"
#define PEN2SG  " -W0.25p,132"
#define PEN2DG  " -W0.25p,132,2_2:0"
#define PEN3S   " -W0.5p,black"
#define PEN3D   " -W0.5p,black,2_2:0"
#define PEN3SG  " -W0.5p,132"
#define PEN3DG  " -W0.5p,132,2_2:0"
#define PEN5S   " -W1.0p,black"
#define PEN5D   " -W1.0p,black,5_5:0"
#define PEN5SG  " -W1.0p,132"
#define PEN5DG  " -W1.0p,132,5_5:0"

#define CIRC2S	" -Sc0.2c -G0 -W1.0p,black"
#define CIRC2SG	" -Sc0.2c -G132 -W1.0p,132"
#define CIRC2O	" -Sc0.2c -G255 -W1.0p,black"
#define CIRC2OG	" -Sc0.2c -G255 -W1.0p,132"
#define CIRC3S	" -Sc0.3c -G0 -W1.0p,black"
#define CIRC3O	" -Sc0.3c -G255 -W1.0p,black"
#define TRIA2S	" -St0.2c -G0 -W1.0p,black"
#define TRIA2O	" -St0.2c -G255 -W1.0p,black"
#define CROS2S	" -Sx0.2c -G0 -W1.0p,black"
#define CROS2D	" -Sx0.2c -G132 -W1.0p,132,2_2:0"
#define STAR3O	" -Sa0.3c -G255 -W1.0p,black"

#define GREY	" -G220"
#define OPTF	" -F+f+j"

/* Type of functions */

void quit_gv();
FILE *pdrc_cmd();
int pdrc_comd(); void do_init(), go_next(), go_back(), go_first(), go_last(), go_plus10(), \
	go_minus10(), core_orient(), situ_orient(), bed_orient(), change_south(), put_mad(), \
	delete_one(), restor_one(), it_initial(), write_results(), out_psfile();
void pdrc_dat(), pdrc_mem1(), pdrc_mem2(), free_all();
void pdrc_fld(), set_gtc_circ(); int pdrc_a95f();
void pdrc_plot(), wrt_tmp(), wrt_tmp2(), wrt_tmp3(), wrt_tmp3i();
void pdrc_sitedat();
void pdrc_statf(), pdrc_rejectf(), pdrc_restorf();
void pdrc_statg(), add_g(), check_ag(), pdrc_rejectg(), pdrc_restorg(), \
	do_one_gtc(), do_two_gtc(); int check_dlt(); double recal_g();
void pdrc_text();
void pdrc_vgp(); int pdrc_a95v();
