#include <string.h>
#include "pdirec.h"

#define MAPF	" -JA180/90/11.0"
#define TICKF	" -Bg90"
#define RANGEF	" -R0/360/0/90"
#define XYF	" -Y13.5"
#define CONT	"%.1f %.1f\n"
#define NGTC	12
#define MAPTXT	" -Jx1 -R0/12.0/0/12.0"
#define TEXTEQ	"11.0  11.0 14p,Helvetica-Bold,black RB %s\n\
 5.5  11.1 14p,Helvetica,black CB 0\n\
11.1   5.5 14p,Helvetica,black LM 90\n\
 5.5  -0.1 14p,Helvetica,black CT 180\n\
-0.1   5.5 14p,Helvetica,black RM 270\n"

extern FILE *Fpt;
extern char Buf[WBUF], *Frame_lbl[];
extern unsigned int Opt, Frm;
extern int Ns, Nsg, Nst, Nstg, *Id, *Rjc, *Idg, *Rjcg;
extern double *Slt, *Sln, **Is, **Ds, *Mad, **Ip, **Dp, **Ia1, **Da1, **Ia2, **Da2;
extern double *Ieq, *Deq, *Ieqr, *Ieqg, *Deqg, *Ieqgr, Im, Dm, A95, Imeq, Dmeq, Imeqr;

static double incg[NGTC+1], decg[NGTC+1], incgr[NGTC+1];

/* pdrc_fld -- plot paleodirections for n th site 
	psxy warning to drawing an empty A95 was fixed   120624
*/

void pdrc_fld(n)
int n;
{
	int i, j;

	/* base map */

	sys_call(7, "gmt psbasemap", MAPF, TICKF, RANGEF, XYF, " -P -O -K >>", FILEP);

	/* plot each paleo direction & MAD if applicable */

	if (Opt & ENBL_MAD_BIT){
	for (i = 0; i < Ns; i++){
	if (Mad[Id[i]] > 0.2){
		if (Rjc[i] == 0){
			pdrc_a95f(Is[Frm][Id[i]], Ds[Frm][Id[i]], Mad[Id[i]], 16, 0);
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2S, " -P -O -K >>", FILEP);
			pdrc_a95f(Is[Frm][Id[i]], Ds[Frm][Id[i]], Mad[Id[i]], 16, 1);
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2D, " -P -O -K >>", FILEP);
		}
		else {
			pdrc_a95f(Is[Frm][Id[i]], Ds[Frm][Id[i]], Mad[Id[i]], 16, 0);
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2SG, " -P -O -K >>", FILEP);
			pdrc_a95f(Is[Frm][Id[i]], Ds[Frm][Id[i]], Mad[Id[i]], 16, 1);
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2DG, " -P -O -K >>", FILEP);
		}
	}
	}
	}
	for (i = 0; i < Ns; i++){
		if (Rjc[i] == 0){
			sprintf(Buf, CONT, Deq[i], Ieq[i]);   wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2S, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, Deq[i], Ieqr[i]);   wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2O, " -P -O -K >>", FILEP);
		}
		else {
			sprintf(Buf, CONT, Deq[i], Ieq[i]);   wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2SG, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, Deq[i], Ieqr[i]);   wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2OG, " -P -O -K >>", FILEP);
		}
	}

	/* plot each GTC and corresponding point G with confinement points */

	for (j = 0; j < Nsg; j++){
		set_gtc_circ(j);
		wrt_tmp2(0, NGTC, CONT, decg, incg);
		if (Rjcg[j] == 0)
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2S, " -P -O -K >>", FILEP);
		else
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2SG, " -P -O -K >>", FILEP);
		wrt_tmp2(0, NGTC, CONT, decg, incgr);
		if (Rjcg[j] == 0)
 			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2D, " -P -O -K >>", FILEP);
		else
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2DG, " -P -O -K >>", FILEP);
		if (Rjcg[j] == 0){
			if ((Ns==0 && Nsg==1) || (Ns==0 && Nsg==2))
				;
			else {
				sprintf(Buf, CONT, Deqg[j], Ieqg[j]);   wrt_tmp();
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, TRIA2S, " -P -O -K >>", \
					FILEP);
				sprintf(Buf, CONT, Deqg[j], Ieqgr[j]);   wrt_tmp();
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, TRIA2O, " -P -O -K >>", \
					FILEP);
			}
			if (Ia1[Frm][Idg[j]] > 0.){
				sprintf(Buf, CONT, 360. - Da1[Frm][Idg[j]], Ia1[Frm][Idg[j]]);
				wrt_tmp();
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CROS2S, " -P -O -K >>", \
					FILEP);
			}
			else {
				sprintf(Buf, CONT, 360. - Da1[Frm][Idg[j]], -Ia1[Frm][Idg[j]]);
				wrt_tmp();
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CROS2D, " -P -O -K >>", \
					FILEP);
			}
			if (Ia2[Frm][Idg[j]] > 0.){
				sprintf(Buf, CONT, 360. - Da2[Frm][Idg[j]], Ia2[Frm][Idg[j]]);
				wrt_tmp();
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CROS2S, " -P -O -K >>", \
					FILEP);
			}
			else {
				sprintf(Buf, CONT, 360. - Da2[Frm][Idg[j]], -Ia2[Frm][Idg[j]]);
				wrt_tmp();
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CROS2D, " -P -O -K >>", \
					FILEP);
			}
		}
	}

	/* plot the site mean direction & circle of A95 for the present coordinate frame */

	if (Nst + Nstg > 1){
		sprintf(Buf, CONT, Dmeq, Imeq);   wrt_tmp();
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3S, " -P -O -K >>", FILEP);
		sprintf(Buf, CONT, Dmeq, Imeqr);   wrt_tmp();
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3O, " -P -O -K >>", FILEP);
	}
	if (A95 > 0.){
		pdrc_a95f(Im, Dm, A95, 64, 0);
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3S, " -P -O -K >>", FILEP);
		pdrc_a95f(Im, Dm, A95, 64, 1);
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3D, " -P -O -K >>", FILEP);
	}

	/* plot labels */

	sprintf(Buf, TEXTEQ, Frame_lbl[Frm]);
	wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPTXT, OPTF, " -N -P -O -K >>", FILEP);
}

/* pdrc_a95f */

int pdrc_a95f(inc, dec, a95, na, flip)
int na, flip;
double inc, dec, a95;
{
	int i;
	double inca[NAMAX+1], deca[NAMAX+1];

	if ((Fpt = fopen(FILET, "w")) == NULL) error("pdrc_a95f: error of open a TMP file!");
	if (alph95(inc, dec, a95, na, inca, deca) == -1) return(-1);
	if (flip == 0)
		for (i = 0; i <= na; i++)
			fprintf(Fpt, CONT, 360. - deca[i], inca[i]);
	else if (flip == 1)
		for (i = 0; i <= na; i++)
			fprintf(Fpt, CONT, 360. - deca[i], -inca[i]);
	fclose(Fpt);
	return(1);
}

/* draw_gtc_circ */

void set_gtc_circ(j)
int j;
{
	int i;
	double dec0 = 0., ddec0, alph, beta, inc1, dec1, inc, dec;

	ddec0 = 360./NGTC;
	alph = 90. - Dp[Frm][Idg[j]];   beta = 90. + Ip[Frm][Idg[j]];
	for (i = 0; i <= NGTC; i++){
		rotuvec(alph, beta, 0., dec0, &inc1, &dec1);
		rotuvec(-alph, 0., inc1, dec1, &inc, &dec);
		checklon(&dec, 0);
		incg[i] = inc;   decg[i] = 360. - dec;   incgr[i] = -inc;
		dec0 += ddec0;
	}
}
#undef MAPF
#undef TICKF
#undef RANGEF
#undef XYF
#undef CONT
#undef NGTC
#undef MAPTXT
#undef TEXTEQ
