#include "pdirec.h"

extern unsigned int Opt, Frm;
extern int Ns, Nsg, Nst, Nstg, *Idsmp, *Idsmpg, *Id, *Rjc, *Idg, *Rjcg;
extern double *Slt, *Sln, **Is, **Ds, **Ip, **Dp;
extern double *Xs, *Ys, *Zs, *Xp, *Yp, *Zp, *Vlt, *Vln, *Vltr, *Vlnr;
extern double *Ieq, *Deq, *Ieqr;

/* pdrc_sitedat -- set up & initialize the data of n th site for statistics and GMT */

void pdrc_sitedat(n)
int n;
{
	int i;

	Opt &= ~IT_INITIAL_BIT;
	Nst = Ns = Idsmp[n+1] - Idsmp[n];
	for (i = 0; i < Ns; i++){
		Id[i] = Idsmp[n] + i;   Rjc[i] = 0;
		magcar(1., Is[Frm][Id[i]], Ds[Frm][Id[i]], Xs+i, Ys+i, Zs+i);
		fldvgp(Slt[n], Sln[n], Is[Frm][Id[i]], Ds[Frm][Id[i]], Vlt+i, Vln+i);
		Ieq[i] = Is[Frm][Id[i]];   Deq[i] = 360. - Ds[Frm][Id[i]];
		Ieqr[i] = -Is[Frm][Id[i]];
		Vltr[i] = -Vlt[i];   Vlnr[i] = Vln[i] + 180.;   checklon(Vlnr+i, 0);
	}
	Nstg = Nsg = Idsmpg[n+1] - Idsmpg[n];
	for (i = 0; i < Nsg; i++){
		Idg[i] = Idsmpg[n] + i;   Rjcg[i] = 0;
		magcar(1., Ip[Frm][Idg[i]], Dp[Frm][Idg[i]], Xp+i, Yp+i, Zp+i);
	}
	if (Nsg == 0)
		pdrc_statf(n);
	else
		pdrc_statg(n, 0., 0.);
}
