#include <math.h>
#include "pinte.h"

#define CNUMB	"%.4f %.4f 9p,Helvetica,black BL %d\n"
#define CNUMBD	"%.4f %.4f 9p,Helvetica,132 BL %d\n"
#define CTEMP	"%.4f %.4f 9p,Helvetica,black BL %.0f\n"
#define CTEMPD	"%.4f %.4f 9p,Helvetica,132 BL %.0f\n"
#define CRANGE	" -R0/%.1f/0/%.1f"
#define CONT	"%.4f %.4f\n"
#define CPTLIN	"%.4f %.4f\n%.4f %.4f\n"

extern char **Sampl, *Id_mthd[], Buf[WBUF];
extern unsigned int Opt;
extern FILE *Fpt;
extern int Nstep, Nptr, Nmdtl, I1, I2, *Idpt1, *Idpt2, Methd, *Ia;
extern double *Step, *Magn, *Magt, *Magp, Scala, Scalax, Scalaxc, *Xa, *Xac, *Xam, *Xacm, \
	*Ya, *Yam, *Xap, *Xacp, *Yap, A, B, Sb, R, Xl0, Yl0, Rl, Kl, Sse;
static char Range[100];
static double *X, *Xp, *Xm;

/* pi_arai -- plot Arai diagram and a line of regression
	option to normalize TRM axis was intorduced   072514
	plot of fitted circle was introduced   092613
*/

void pi_arai(n)
int n;
{
	int i;

	/* To use same code for TRM normalized or not, copy Xa[]... to static X[]... */

	X = mallocvd(Nstep);   Xp = mallocvd(Nptr);   Xm = mallocvd(Nmdtl);
	if (!(Opt & NORM_TRM_BIT)){
		for (i=0; i<Nstep; i++) X[i] = Xa[i];
		for (i=0; i<Nptr; i++) Xp[i] = Xap[i];
		for (i=0; i<Nmdtl; i++) Xm[i] = Xam[i];
		sprintf(Range, CRANGE, XAMAX*Scala*Scalax, YAMAX*Scala);
		sys_call(7, "gmt psbasemap", MAPA, TICKA, Range, XYA, " -P -O -K >>", FILEP);
	}
	else {
		for (i=0; i<Nstep; i++) X[i] = Xac[i];
		for (i=0; i<Nptr; i++) Xp[i] = Xacp[i];
		for (i=0; i<Nmdtl; i++) Xm[i] = Xacm[i];
		sprintf(Range, CRANGE, XAMAX*Scala*Scalaxc, YAMAX*Scala);
		sys_call(7, "gmt psbasemap", MAPA, TICKAC, Range, XYA, " -P -O -K >>", FILEP);
	}

	/* plot pTRM test by dimmed triangles */

	if (Nptr > 0){
		if ( !(Opt & PTR_NOLINE_BIT) )
			for (i = 0; i < Nptr; i++) draw_ptrlin(i);
		wrt_tmp2(0, Nptr-1, CONT, Xp, Yap);
		sys_call(7, "gmt psxy ", FILET, MAPA, Range, TRIA8SG, " -P -O -K >>", FILEP);
	}

	/* plot MD pTRM tail check by dimmed square */

	if (Nmdtl > 0){
		wrt_tmp2(0, Nmdtl-1, CONT, Xm, Yam);
		sys_call(7, "gmt psxy ", FILET, MAPA, Range, SQUAR8G, " -P -O -K >>", FILEP);
	}

	/* if REGRES_BIT or CIRCLE_BIT is ON, plot a regression line or circle first */

	if (Opt & REGRES_BIT){
		sprintf(Buf, CPTLIN, 0., A, -A/B, 0.);  wrt_tmp();
		sys_call(7, "gmt psxy ", FILET, MAPA, Range, PEN5SG, " -P -O -K >>", FILEP);
		sprintf(Buf, CPTLIN, X[I1], A+B*X[I1], X[I2], A+B*X[I2]);  wrt_tmp();
		sys_call(7, "gmt psxy ", FILET, MAPA, Range, PEN5S, " -P -O -K >>", FILEP);
	}

	if (Opt & CIRCLE_BIT){
		wrt_circle(0);
		sys_call(7, "gmt psxy ", FILET, MAPA, Range, PEN5SG, " -P -O -K >>", FILEP);
		wrt_circle(+1);
		sys_call(7, "gmt psxy ", FILET, MAPA, Range, PEN5S, " -P -O -K >>", FILEP);
	}

	/* dimmed plots for data outside of I1 & I2 */

	if (I1 > 0){
		wrt_tmp2(0, I1, CONT, X, Ya);
		sys_call(7, "gmt psxy ", FILET, MAPA, Range, CIRC8SG, " -P -O -K >>", FILEP);
		if (Opt & TEMP_BIT){
			wrt_tmp3(0, I1, CTEMPD, X, Ya, Step);
			sys_call(8, "gmt pstext ", FILET, MAPA, Range, OPTF, DSHIFT4, \
				" -P -O -K >>", FILEP);
		}
		else if (Opt & NUMBER_BIT){
			wrt_tmp3i(0, I1, CNUMBD, X, Ya, Ia);
			sys_call(8, "gmt pstext ", FILET, MAPA, Range, OPTF, DSHIFT4, \
				" -P -O -K >>", FILEP);
		}
	}
	if (I2 < Nstep){
		wrt_tmp2(I2, Nstep-1, CONT, X, Ya);
		sys_call(7, "gmt psxy ", FILET, MAPA, Range, CIRC8SG, " -P -O -K >>", FILEP);
		if (Opt & TEMP_BIT){
			wrt_tmp3(I2, Nstep-1, CTEMPD, X, Ya, Step);
			sys_call(8, "gmt pstext ", FILET, MAPA, Range, OPTF, DSHIFT4, \
				" -P -O -K >>", FILEP);
		}
		else if (Opt & NUMBER_BIT){
			wrt_tmp3i(I2, Nstep-1, CNUMBD, X, Ya, Ia);
			sys_call(8, "gmt pstext ", FILET, MAPA, Range, OPTF, DSHIFT4, \
				" -P -O -K >>", FILEP);
		}
	}

	/* plot data between I1 & I2 */

	wrt_tmp2(I1, I2, CONT, X, Ya);
	sys_call(7, "gmt psxy ", FILET, MAPA, Range, CIRC8S, " -P -O -K >>", FILEP);
	if (Opt & TEMP_BIT){
		wrt_tmp3(I1, I2, CTEMP, X, Ya, Step);
		sys_call(8, "gmt pstext ", FILET, MAPA, Range, OPTF, DSHIFT4, \
			" -P -O -K >>", FILEP);
	}
	else if (Opt & NUMBER_BIT){
		wrt_tmp3i(I1, I2, CNUMB, X, Ya, Ia);
		sys_call(8, "gmt pstext ", FILET, MAPA, Range, OPTF, DSHIFT4, \
			" -P -O -K >>", FILEP);
	}

	/* plot texts and conclude GMT output */

	if (!(Opt & REGRES_BIT) && !(Opt & CIRCLE_BIT)){
		sprintf(Buf, TEXTA, Sampl[n], Id_mthd[Methd]);  wrt_tmp();
		sys_call(6, "gmt pstext ", FILET, MAPAT, OPTF, " -P -O >>", FILEP);
	}
	else {
		if (!(Opt & NORM_TRM_BIT)){
			if (Opt & REGRES_BIT){
				sprintf(Buf, TEXTAR, Sampl[n], B, Sb, R, Id_mthd[Methd]);
				wrt_tmp();
				sys_call(6, "gmt pstext ", FILET, MAPAT, OPTF, " -P -O >>", FILEP);
			}
			else {
				sprintf(Buf, TEXTAC, Sampl[n], Rl, Kl, Sse, Id_mthd[Methd]);
				wrt_tmp();
				sys_call(6, "gmt pstext ", FILET, MAPAT, OPTF, " -P -O >>", FILEP);
			}
		}
		else {
			if (Opt & REGRES_BIT){
				sprintf(Buf, TEXTARM, Sampl[n], B, Sb, R, Id_mthd[Methd]);
				wrt_tmp();
				sys_call(6, "gmt pstext ", FILET, MAPAT, OPTF, " -P -O >>", FILEP);
			}
			else {
				sprintf(Buf, TEXTACM, Sampl[n], Rl, Kl, Sse, Id_mthd[Methd]);
				wrt_tmp();
				sys_call(6, "gmt pstext ", FILET, MAPAT, OPTF, " -P -O >>", FILEP);
			}
		}
	}
	freevd(X);   freevd(Xp);   freevd(Xm);
}

/* draw_ptrlin */

void draw_ptrlin(i)
int i;
{
	sprintf(Buf, CPTLIN, X[Idpt1[i]], Ya[Idpt1[i]], Xp[i], Ya[Idpt1[i]]);  wrt_tmp();
	sys_call(7, "gmt psxy ", FILET, MAPA, Range, PEN3SG, " -P -O -K >>", FILEP);
	sprintf(Buf, CPTLIN, Xp[i], Ya[Idpt1[i]], Xp[i], Ya[Idpt2[i]]);  wrt_tmp();
	sys_call(7, "gmt psxy ", FILET, MAPA, Range, PEN3SG, " -P -O -K >>", FILEP);
}

/* wrt_circle -- data for drawing a circle 
	intv=0: (xl,yl) for all the temp range
	intv=1: (xl,yl) for the segment of linear regression
*/

void wrt_circle(intv)
int intv;
{
	double xl, xlmin, xlmax, dxl, yl, dum;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	if (intv == 0){
		xl = xlmin = 0.;   yl = 1.;   xlmax = X[Nstep-1];
		dxl = xlmax/100.;
		while (xl<=Xl0+Rl && yl>=0.0){
			if ((dum = Rl*Rl - (xl - Xl0)*(xl - Xl0)) < 0.){
				xl += dxl; 
				continue;
			}
			if (Kl > 0.) yl = Yl0 - sqrt(dum);
			else yl = Yl0 + sqrt(dum);
			fprintf(Fpt, CONT, xl, yl);
			xl += dxl;
		}
	}
	else if (intv == 1){
		xl = xlmin = X[I1];   yl = 1.;   xlmax = X[I2];
		dxl = fabs(xlmax - xlmin)/100.;
		while (xl<=xlmax && yl>=0.0){
			if ((dum = Rl*Rl - (xl - Xl0)*(xl - Xl0)) < 0.){
				xl += dxl; 
				continue;
			}
			if (Kl > 0.) yl = Yl0 - sqrt(dum);
			else yl = Yl0 + sqrt(dum);
			fprintf(Fpt, CONT, xl, yl);
			xl += dxl;
		}
	}
	else
		error("Wrong intv option in wrt_cricle.");
	fclose(Fpt);
}
#undef CNUMB
#undef CNUMBD
#undef CTEMP
#undef CTEMPD
#undef CRANGE
#undef CONT
#undef CPTLIN
