#include "pinte.h"

#define CONTR " -R0/700/%.1f/%.1f"
#define CONTT	" -BWeSn -Bxf100a200+l\"Step (\\260C)\" -Byf%.1fa%.1f+l\"@~c@~/@~c@~@-20@-\""
#define CONT "%.3f %.3f\n"

extern char Buf[WBUF];
extern int Nstep, Nptr, Nmdtl, I1, I2;
extern double *Chin, *Step, *Ycn, *Yct, *Ycp, *Ycm, Ycmax, Ycmin, dYca, dYct;

static char Range[100], Tick[100], Chi[50];

/* pi_chi -- plot a Chi-Step curve when PLOT_CHI_BIT is ON.
	The host program shoud check whether READ_CHI_BIT is ON.
*/

void pi_chi()
{
	/* set up axis & tick parameters */

	sprintf(Range, CONTR, Ycmin, Ycmax);
	sprintf(Tick, CONTT, dYct, dYca);
	sys_call(7, "gmt psbasemap ", MAPC, Tick, Range, XYC, " -P -O -K >>", FILEP);

	/* plot pTRM tests & MD pTRM tail checks by dimmed symbols */

	if (Nptr > 0){
		wrt_tmp2(0, Nptr-1, CONT, Step, Ycp);
		sys_call(7, "gmt psxy ", FILET, MAPC, Range, TRIA3OG, " -P -O -K >>", FILEP);
	}
	if (Nmdtl > 0){
		wrt_tmp2(0, Nmdtl-1, CONT, Step, Ycm);
		sys_call(7, "gmt psxy ", FILET, MAPC, Range, TRIA3SG, " -P -O -K >>", FILEP);
	}

	/* plot chi-step data */

	if (I1 > 0){
		wrt_tmp2(0, I1, CONT, Step, Ycn);
		sys_call(7, "gmt psxy ", FILET, MAPC, Range, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPC, Range, CIRC5SG, " -P -O -K >>", FILEP);
		if (I1 > 1){
			wrt_tmp2(1, I1, CONT, Step, Yct);
			sys_call(7, "gmt psxy ", FILET, MAPC, Range, PEN3SG, " -P -O -K >>", FILEP);
			sys_call(7, "gmt psxy ", FILET, MAPC, Range, CIRC5OG, " -P -O -K >>", FILEP);
		}
	}
	if (I2 < Nstep){
		wrt_tmp2(I2, Nstep-1, CONT, Step, Ycn);
		sys_call(7, "gmt psxy ", FILET, MAPC, Range, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPC, Range, CIRC5SG, " -P -O -K >>", FILEP);
		wrt_tmp2(I2, Nstep-1, CONT, Step, Yct);
		sys_call(7, "gmt psxy ", FILET, MAPC, Range, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPC, Range, CIRC5OG, " -P -O -K >>", FILEP);
	}
	wrt_tmp2(I1, I2, CONT, Step, Ycn);
	sys_call(7, "gmt psxy ", FILET, MAPC, Range, PEN3S, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, MAPC, Range, CIRC5S, " -P -O -K >>", FILEP);
	if (I1 < 1)
		wrt_tmp2(1, I2, CONT, Step, Yct);
	else
		wrt_tmp2(I1, I2, CONT, Step, Yct);

	sys_call(7, "gmt psxy ", FILET, MAPC, Range, PEN3S, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, MAPC, Range, CIRC5O, " -P -O -K >>", FILEP);

	/* plot texts */

	sprintf(Chi, "%.2e", Chin[0]);
	sprintf(Buf, TEXTC, Chi);  wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPCT, OPTF, " -P -O -K >>", FILEP);
}
#undef CONTR
#undef CONTT
#undef CONT
