#include <string.h>
#include "pinte.h"

#define CONT	"%.1f %.1f\n"

extern char Buf[WBUF];
extern unsigned int Opt;
extern int Nstep, Nptr, Nmdtl, I1, I2;
extern double *Ienn, *Denn, *Ienr, *Iemn, *Demn, *Iemr, *Ietn, *Detn, *Ietr, \
		*Iepn, *Depn, *Iepr;

static char In_situ[10];

/* pi_eqn -- equal area plot of NRM vectors with MD pTRM tail checks indicated by dimmed triangles */

void pi_eqn()
{
	int i;

	sys_call(7, "gmt psbasemap", MAPE, TICKE, RANGEE, XYEN, " -P -K >", FILEP);

	/* dimmed plot of MD pTRM tail check by solid & open triangle */

	if (Nmdtl > 0){
		wrt_tmp2(0, Nmdtl-1, CONT, Demn, Iemn);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, TRIA3SG, " -P -O -K >>", FILEP);
		wrt_tmp2(0, Nmdtl-1, CONT, Demn, Iemr);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, TRIA3OG, " -P -O -K >>", FILEP);
	}

	/* plot NRM by circles, dimmed when out of region */

	if (I1 > 0){
		wrt_tmp2(0, I1, CONT, Denn, Ienn);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5SG, " -P -O -K >>", FILEP);
		wrt_tmp2(0, I1, CONT, Denn, Ienr);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5OG, " -P -O -K >>", FILEP);
	}
	if (I2 < Nstep){
		wrt_tmp2(I2, Nstep-1, CONT, Denn, Ienn);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5SG, " -P -O -K >>", FILEP);
		wrt_tmp2(I2, Nstep-1, CONT, Denn, Ienr);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5OG, " -P -O -K >>", FILEP);
	}
	wrt_tmp2(I1, I2, CONT, Denn, Ienn);
	sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3S, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5S, " -P -O -K >>", FILEP);
	wrt_tmp2(I1, I2, CONT, Denn, Ienr);
	sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3D, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5O, " -P -O -K >>", FILEP);

	/* plot texts */

	if ( !(Opt & IN_SITU_BIT) ) strcpy(In_situ, "CORE");
	else strcpy(In_situ, "IN SITU");
	sprintf(Buf, TEXTE, "NRM", In_situ);  wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPET, OPTF, " -P -O -K >>", FILEP);
}

/* pi_eqt -- equal area plot of TRM vectors (pTRM test is indicated by triangle) */

void pi_eqt()
{
	int i, i1;

	sys_call(7, "gmt psbasemap", MAPE, TICKE, RANGEE, XYET, " -P -O -K >>", FILEP);

	/* dimmed plots of pTRM test directions by solid & open triangles */

	if (Nptr > 0){
		wrt_tmp2(0, Nptr-1, CONT, Depn, Iepn);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, TRIA3SG, " -P -O -K >>", FILEP);
		wrt_tmp2(0, Nptr-1, CONT, Depn, Iepr);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, TRIA3OG, " -P -O -K >>", FILEP);
	}

	/* plot TRM with dimmed for the region outside of regression (0th data is omitted )*/

	if (I1 == 0) i1 = 1;
	else i1 = I1;
	if (i1 > 1){
		wrt_tmp2(1, i1, CONT, Detn, Ietn);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5SG, " -P -O -K >>", FILEP);
		wrt_tmp2(1, i1, CONT, Detn, Ietr);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5OG, " -P -O -K >>", FILEP);
	}
	if (I2 < Nstep){
		wrt_tmp2(I2, Nstep-1, CONT, Detn, Ietn);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5SG, " -P -O -K >>", FILEP);
		wrt_tmp2(I2, Nstep-1, CONT, Detn, Ietr);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5OG, " -P -O -K >>", FILEP);
	}
	wrt_tmp2(i1, I2, CONT, Detn, Ietn);
	sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3S, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5S, " -P -O -K >>", FILEP);
	wrt_tmp2(i1, I2, CONT, Detn, Ietr);
	sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, PEN3D, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, MAPE, RANGEE, CIRC5O, " -P -O -K >>", FILEP);

	/* plot texts */

	if ( !(Opt & IN_SITU_BIT) ) strcpy(In_situ, "CORE");
	else strcpy(In_situ, "IN SITU");
	sprintf(Buf, TEXTE, "TRM", In_situ);  wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPET, OPTF, " -P -O -K >>", FILEP);
}
#undef CONT
