#include <string.h>
#include <math.h>
#include "pinte.h"

#define EXT	".PI"
#define TITLE	"Results of %s (Thellier-%s experiment from %s)\n\n"
#define TITLEM	"Results of %s (Thellier-%s experiment from %s)\n\
  *** TRM NORMALIZED TO UNITY *** (params \"*\" affected; NRM/TRM_Max=%.3f)\n\n"
#define HEAD1	"NRM & TRM vectors at each step:\n\
 i  Step  Magn     Incn  Decn  Magt      Inct  Dect  NRM  TRM\n"
#define HEAD1M	"NRM & TRM vectors at each step:\n\
 i  Step  Magn     Incn  Decn  Magt      Inct  Dect  NRM  TRM*\n"
#define HEAD2	"\npTRM tests:\n\
From To   Magp     Incp  Decp  PT/T  Magdp    Incdp Decdp pTRM   dp/xt  DRAT\n"
#define HEAD2M	"\npTRM tests:\n\
From To   Magp     Incp  Decp  PT/T  Magdp    Incdp Decdp pTRM*  dp/xt  DRAT*\n"
#define HEAD3	"\nMD tail tests:\n\
 i  Step  Magn2    Incn2 Decn2 N2/N  MagMDtl  IncMD DecMD MDtl  MDtl/yt\n"
#define HEAD4	"\nLine & circle for the selected segment:\n\
nr  I1  I2     b     sb   sb/b     r      f      g     q        a     sa    cdpt   CDRAT\n"
#define HEAD4M	"\nLine & circle for the selected segment:\n\
nr  I1  I2     b*    sb*  sb/b     r      f      g     q        a     sa    cdpt   CDRAT*\n"
#define HEAD4c	"\n  fn     fv     FRAC   kc    SSE      X0     Y0     rc   ssel-line ssel-line2\n"
#define HEAD4cM	"\n  fn     fv     FRAC   kc*   SSE*     X0*    Y0*    rc*  ssel-lin* ssel-lin2*\n"
#define HEAD4z	"\n  fn     fv     FRAC   Zstr   Z1     Z2     kc    SSE       X0     Y0     rc   sse-line sse-line2\n"
#define HEAD4zM	"\n  fn     fv     FRAC   Zstr*  Z1     Z2     kc*   SSE*      X0*    Y0*    rc*  sse-lin* sse-lin2*\n"
#define HEAD45	"\nCircles for the data points in selected/all ranges (TRM normalized):\n\
 I1  I2   kc*   SSE*      X0*    Y0*    rc*   /  I0  IN   kc*   SSE*      X0*    Y0*    rc*\n"
#define HEAD46	"\nCircle for selected data points normalized by (N[I1]-N[I2]) & (T[I2]-T[I1]):\n\
 I1  I2   kc'   SSE'      X0'    Y0'    rc'\n"
#define HEAD5	"\nRemanence direction of the selected segment:\n\
nr  I1  I2  inc_c dec_c  MAD  theta  devn    devl  inc_s dec_s\n"
#define HEAD5g	"\nRemanence direction of the selected segment (Anchored):\n\
nr  I1  I2  inc_c dec_c  MAD  inc_s dec_s\n"
#define HEAD6	"\nRemanence direction of the selected segment:\n\
nr  I1  I2  inc_s dec_s  MAD  theta  devn    devl  inc_c dec_c\n"
#define HEAD6g	"\nRemanence direction of the selected segment (Anchored):\n\
nr  I1  I2  inc_s dec_s  MAD  inc_c dec_c\n"
#define CONT0	"  b     sb     r     fv   MAD theta:\n%.3f %.3f %.3f %.3f %.1f %.1f\n"
#define CONT0g	"  b     sb     r     fv   MAD (Anchored):\n%.3f %.3f %.3f %.3f %.1f\n"
#define CONT0C	" rc    kc    SSE    MAD theta:\n%.2f %.3f %.2e %.1f %.1f\n"
#define CONT0gC	" rc    kc    SSE    MAD (Anchored):\n%.2f %.3f %.2e %.1f\n"
#define CONT1	"%3d %3.0f %9.3e %5.1f %5.1f %9.3e %5.1f %5.1f %5.3f %5.3f\n"
#define CONT2	"%3.0f %3.0f %9.3e %5.1f %5.1f %5.3f %9.3e %5.1f %5.1f %5.3f %6.3f %6.3f\n"
#define CONT3	"%3d %3.0f %9.3e %5.1f %5.1f %5.3f %9.3e %5.1f %5.1f %5.3f %6.3f\n"
#define CONT4	"%2d %3.0f %3.0f %6.4f %6.4f %5.3f %6.4f %6.4f %6.4f %6.4f %6.4f %6.4f %6.3f %6.3f\n"
#define CONT4c	"%6.3f %6.3f %6.3f %6.3f %8.2e %6.2f %6.2f %6.2f %8.2e %8.2e\n"
#define CONT4z	"%6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %8.2e %6.2f %6.2f %6.2f %8.2e %8.2e\n"
#define CONT45	"%3.0f %3.0f %6.3f %8.2e %6.2f %6.2f %6.2f"
#define CONT452	"  / %3.0f %3.0f %6.3f %8.2e %6.2f %6.2f %6.2f\n"
#define CONT46	"%3.0f %3.0f %6.3f %8.2e %6.2f %6.2f %6.2f\n"
#define CONT5	"%2d %3.0f %3.0f %5.1f %5.1f %5.1f %5.1f %7.3f %7.3f %5.1f %5.1f\n"
#define CONT5g	"%2d %3.0f %3.0f %5.1f %5.1f %5.1f %5.1f %5.1f\n"

extern char **Sampl, *Id_mthd[], Filed[WFILE];
extern unsigned int Opt;
extern int Nstep, Nptr, Nmdtl, I1, I2, *Idpt1, *Idpt2, *Idmd, Methd;
extern double *Azim, *Plun, *Step, *Magn, *Incn, *Decn, *Magn2, *Incn2, *Decn2, \
	*Magmd, *Incmd, *Decmd, *Magt, *Inct, *Dect, *Magp, *Incp, *Decp, *Xa, *Xac, \
	*Xap, *Xacp, *Xam, *Xacm, *Ya, *Yam, A, B, Sb, R, F, G, Q, L, *Xzn, *Yzn, *Zzn, \
	Xzn1, Xzn2, Yyr1, Yyr2, Yzr1, Yzr2, Factzjn, Xl0, Yl0, Rl, Kl, Sse, NrmbarTmax;
static int nr;
static double sa, *X, *Xp, *Xm;

/* pi_regres -- analysis of Arai plot following Coe et al. 1978   040902
		PCA analysis of NRM steps on Zj-plot is made for gmt data
	some parameters of my idea for judgement of the Arai plot
		theta -- diff angle of the line direction from the center of mass
		dev -- minimum distance of the line from the origin
		dn/yt -- MD pTRM tail devided by total extrapolated NRM
		dp/xt -- change in pTRM test devided by total extrapolated TRM
			(dn & dp are difference in absolute values)

	circle to normalized as (N[i]-N[I2])/(N[I1]-N[I2]) & (T[i]-T[I1])/(T[I2]-T[I1])   081614
	normalization of TRM axis is available (variables *Xac, *Xacp, ...)   072514
	Kl,Sse,Xl0,Yl0,Rl -- params of Paterson11, center & radius of fitted circle   092613
	(fn), fv, fr -- dyt/nrm (=f*a), fvds of TS04, & FRAC of ST13 are added   041713
	zst0,zst1,zst2 -- Z-star to evaluate IZZI result by Yu 2012 and two my own params   102512
	cdpt (accumulation of dpt), devn & devl (nrm & L normalized dev) are introduced   072405
	dev is now normalized by the length L of the linear segment   072005
	DRAT (Selkin & Tauxe, 00) & CDRAT (Kissel & Laj, 04) introudece   061705
*/

void pi_regres(n)
int n;
{
	int anchor = 0, i;
	double xb, yb, zb, ux, uy, uz, mad, incb, decb, incu, decu, theta, devn, devl, \
		fv, fr, ssel, ssel2, zs0=0., zs1=0., zs2=0., dumm;

	X = mallocvd(Nstep);   Xp = mallocvd(Nptr);   Xm = mallocvd(Nmdtl);
	if (!(Opt & NORM_TRM_BIT)){
		for (i=0; i<Nstep; i++) X[i] = Xa[i];
		for (i=0; i<Nptr; i++) Xp[i] = Xap[i];
		for (i=0; i<Nmdtl; i++) Xm[i] = Xam[i];
	}
	else {
		for (i=0; i<Nstep; i++) X[i] = Xac[i];
		for (i=0; i<Nptr; i++) Xp[i] = Xacp[i];
		for (i=0; i<Nmdtl; i++) Xm[i] = Xacm[i];
	}
	if (Opt & ANCHOR_BIT) anchor = 1;
	nr = I2 - I1 + 1;
	linregc(nr, X+I1, Ya+I1, &A, &B, &sa, &Sb, &R, &F, &G, &Q, &L, &ssel, &ssel2);
	cal_frac(&fv, &fr);
	cal_circle(nr, X+I1, Ya+I1, &Xl0, &Yl0, &Rl, &Kl, &Sse);
	if (Methd == IZZI) cal_zstar(nr, X+I1, Ya+I1, &zs0, &zs1, &zs2);
	pcalin(Xzn+I1, Yzn+I1, Zzn+I1, nr, anchor, &xb, &yb, &zb, &ux, &uy, &uz, &mad);
	carmag(xb, yb, zb, &dumm, &incb, &decb);
	carmag(ux, uy, uz, &dumm, &incu, &decu);
	theta = angdif(1., incb, decb, 1., incu, decu);
	set_zjrgline(xb, yb, zb, ux, uy, uz, &devn, &devl);
	if (Opt & REGRES_BIT){
		if (!(Opt & ANCHOR_BIT))
			fprintf(stdout, CONT0, B, Sb, R, fv, mad, theta);
		else
			fprintf(stdout, CONT0g, B, Sb, R, fv, mad);
	}
	else {
		if (!(Opt & ANCHOR_BIT))
			fprintf(stdout, CONT0C, Rl, Kl, Sse, mad, theta);
		else
			fprintf(stdout, CONT0gC, Rl, Kl, Sse, mad);
	}
	wrt_result(n, incu, decu, mad, theta, devn, devl, fv, fr, zs0, zs1, zs2, Sse, ssel, ssel2);
	freevd(X);   freevd(Xp);   freevd(Xm);
}

/* cal_circle -- calculate parameters fitted to a circle following Paterson 2011 */

void cal_circle(n, x, y, x0, y0, r, k, sse)
int n;
double *x, *y, *x0, *y0, *r, *k, *sse;
{
	double xm, ym, *edum;

	edum = mallocvd(n);
	if (circreg(n, x, y, x0, y0, r, &xm, &ym, edum, sse) == -1)
		error("Error at circreg()!");
	if ((*x0)==xm && (*y0)==ym) *k = 0.;
	else if ((*x0)>xm && (*y0)>ym) *k = 1./(*r);
	else if ((*x0)<xm && (*y0)<ym) *k = -1./(*r);
	else {
		*k = 1./(*r);
		fprintf(stderr, "Strange circle center!\n");
	}
	freevd(edum);
}

/* cal_frac -- calculate fvds of Taux & Staudigel (2004) & FRAC of Shaar & Tauxe (2013).
		f is treated in linregc() and fn is written in wrt_result(), where
		fn=dyt/nrm while f=dyt/yt.
*/

void cal_frac(fv, fr)
double *fv, *fr;
{
	int i;
	double sumr = 0., sumn = 0., dumn, dumi, dumd;

	for (i=I1; i<I2; i++){
		vecsub(Magn[i+1],Incn[i+1],Decn[i+1],Magn[i],Incn[i],Decn[i],&dumn,&dumi,&dumd);
		sumr += dumn;
	}
	sumr /= Magn[0];
	for (i=0; i<Nstep-1; i++){
		vecsub(Magn[i+1],Incn[i+1],Decn[i+1],Magn[i],Incn[i],Decn[i],&dumn,&dumi,&dumd);
		sumn += dumn;
	}
	sumn += Magn[Nstep-1];
	sumn /= Magn[0];
	*fv = F*A/sumn;
	*fr = sumr/sumn;
}

/* cal_zstar -- calculate a zigzag pram Z-star in IZZI result based on Yu 2012   102512
	z0 = 100 sum( x[i]/xt |((y[i]-A)/x[i] - B)/A| )/(n-1) -- Yu 2012
	z1 = 100 sum( x[i]/xt |((y[i]-A)/x[i] - B)/B| )/n
	z2 = 100 sum( (x[i+1]-x[i])/xl |((y[i+1]-y[i])/(x[i+1]-x[i]) - B)/B| )/(n-1)
*/

void cal_zstar(n, x, y, z0, z1, z2)
int n;
double *x, *y, *z0, *z1, *z2;
{
	int i, i0 = 0, ni = n;
	double bi, ri, xt, xl, s = 0.;

	xt = -A/B;
	if (x[0] == 0.){
		i0 = 1;
		ni = n-1;
	}
	for (i=i0; i<n; i++)
		s += (x[i]/xt)*fabs((y[i] - A)/x[i] - B);
	*z0 = (s*100./A)/(ni-1);
	*z1 = (s*100./fabs(B))/ni;

	xl = x[n-1] - x[0];
	s = 0.;
	for (i=0; i<n-1; i++)
		s += (x[i+1] - x[i])*fabs((y[i+1] - y[i])/(x[i+1] - x[i]) - B);
	*z2 = (s*100./fabs(xl*B))/(n-1);
}

/* set_zjrgline -- set edge points to draw a regression line on Zj plot
		(Xzn1,Yyr1)-(Xzn2,Yyr2) -- projection to x-y plane (y = a + bx)
		(Xzn1,Yzr1)-(Xzn2,Yzr2) -- projection to x-z plane (z = c + dx)
	dev -- distance of the line from the origin devided by L (formerly devided by yn, 
		but this gives smaller dev when there is a large secondary component)   072005
	devn, devl -- distance of the line from the origin normalized by yn & L   072405
*/

void set_zjrgline(xb, yb, zb, ux, uy, uz, devn, devl)
double xb, yb, zb, ux, uy, uz, *devn, *devl;
{
	double a, b, c, d, dum1, dum2, dum3;

	b = uy/ux;   a = yb - b*xb;
	d = uz/ux;   c = zb - d*xb;
	Yyr1 = a + b*Xzn1;   Yyr2 = a + b*Xzn2;
	Yzr1 = c + d*Xzn1;   Yzr2 = c + d*Xzn2;
	dum1 = xb*xb + yb*yb + zb*zb;   dum2 = xb*ux + yb*uy + zb*uz;
	dum3 = sqrt(dum1 - dum2*dum2);
	*devn = dum3/(Factzjn*A*Magn[0]);
	*devl = dum3/(Factzjn*L*Magn[0]);
}

/* wrt_result -- write regression results for a sample into sample.PI */

void wrt_result(n, inc, dec, mad, theta, devn, devl, fv, fr, zs0, zs1, zs2, sse, ssel, ssel2)
int n;
double inc, dec, mad, theta, devn, devl, fv, fr, zs0, zs1, zs2, sse, ssel, ssel2;
{
	FILE *fp;
	char file[100];
	int i;
	double *magdn, *incdn, *decdn, *magdp, *incdp, *decdp, xt, dumm, dumi, dumd, \
		x0, y0, z0, x, y, z, dpt, cdpt = 0., drat, cdrat = 0.;
	/* circle fit for N[i]/N[I1] & T[i]/T[I2] */
	double *xn, *yn, xn0, yn0, rn, kn, ssen;

	magdn = mallocvd(Nstep);   incdn = mallocvd(Nstep);   decdn = mallocvd(Nstep);
	magdp = mallocvd(Nptr);   incdp = mallocvd(Nptr);   decdp = mallocvd(Nptr);
	xn = mallocvd(Nstep);   yn = mallocvd(Nstep);

	/* title line */

	strcpy(file, Sampl[n]);
	strcat(file, EXT);
	if ((fp = fopen(file, "w")) == NULL) error("Error of open a result file!");
	if (!(Opt & NORM_TRM_BIT)){
		fprintf(fp, TITLE, Sampl[n], Id_mthd[Methd], Filed);
		fprintf(fp, HEAD1);
	}
	else {
		fprintf(fp, TITLEM, Sampl[n], Id_mthd[Methd], Filed, NrmbarTmax);
		fprintf(fp, HEAD1M);
	}

	/* step data */

	for (i = 0; i < Nstep; i++)
		fprintf(fp, CONT1, i, Step[i], Magn[i], Incn[i], Decn[i], Magt[i], \
			Inct[i], Dect[i], Ya[i], X[i]);
	magdn[0] = incdn[0] = decdn[0] = 0.;

	/* pTRM test & MD pTRM tail */

	if (Nptr > 0){
		xt = -A/B;
		if (!(Opt & NORM_TRM_BIT)) fprintf(fp, HEAD2);
		else fprintf(fp, HEAD2M);
		for (i = 0; i < Nptr; i++){
			dumm = Xp[i] - X[Idpt2[i]];
			dpt = dumm/xt;
			drat = dumm/L;
			if (Idpt2[i] >= I1 && Idpt1[i] <= I2){
				cdpt += dpt;   cdrat += drat;
			}
			vecsub(Magp[i], Incp[i], Decp[i], Magt[Idpt2[i]], Inct[Idpt2[i]], \
				Dect[Idpt2[i]], magdp+i, incdp+i, decdp+i);
			fprintf(fp, CONT2, Step[Idpt1[i]], Step[Idpt2[i]], Magp[i], Incp[i], \
				Decp[i], Magp[i]/Magt[Idpt2[i]], magdp[i], incdp[i], decdp[i], \
				Xp[i], dpt, drat);
		}
	}
	if (Nmdtl > 0){
		fprintf(fp, HEAD3);
		for (i = 0; i < Nmdtl; i++){
			fprintf(fp, CONT3, i, Step[Idmd[i]], Magn2[i], Incn2[i], Decn2[i], \
				Magn2[i]/Magn[Idmd[i]], Magmd[i], Incmd[i], Decmd[i], \
				Yam[i], Yam[i]/A);
		}
	}

	/* result of linear regression & circle fitting */

	if (!(Opt & NORM_TRM_BIT)) fprintf(fp, HEAD4);
	else fprintf(fp, HEAD4M);
	fprintf(fp, CONT4, nr, Step[I1], Step[I2], B, Sb, -Sb/B, R, F, G, Q, A, sa, cdpt, cdrat);
	if(Methd != IZZI){
		if (!(Opt & NORM_TRM_BIT)) fprintf(fp, HEAD4c);
		else fprintf(fp, HEAD4cM);
		fprintf(fp, CONT4c, F*A, fv, fr, Kl, Sse, Xl0, Yl0, Rl, ssel, ssel2);
	}
	else {
		if (!(Opt & NORM_TRM_BIT)) fprintf(fp, HEAD4z);
		else fprintf(fp, HEAD4zM);
		fprintf(fp, CONT4z, F*A, fv, fr, zs0, zs1, zs2, Kl, Sse, Xl0, Yl0, Rl, ssel, ssel2);
	}

	/* two circles for best fit segment & all data points with normalized TRM, then 3rd circle */
	/* for the segment normalized as (N[i]-N[I2])/(N[I1]-N[I2]) & (T[i]-T[I1])/(T[I2]-T[I1]) */

	for (i=0; i<Nstep; i++){
		xn[i] = Xac[i];   yn[i] = Ya[i];
	}
	cal_circle(nr, xn+I1, yn+I1, &xn0, &yn0, &rn, &kn, &ssen);
	fprintf(fp, HEAD45);
	fprintf(fp, CONT45, Step[I1], Step[I2], kn, ssen, xn0, yn0, rn);
	cal_circle(Nstep, xn, yn, &xn0, &yn0, &rn, &kn, &ssen);
	fprintf(fp, CONT452, Step[0], Step[Nstep-1], kn, ssen, xn0, yn0, rn);
	for (i=0; i<Nstep; i++){
		xn[i] = (Xa[i] - Xa[I1])/(Xa[I2] - Xa[I1]);
		yn[i] = (Ya[i] - Ya[I2])/(Ya[I1] - Ya[I2]);
	}
	cal_circle(nr, xn+I1, yn+I1, &xn0, &yn0, &rn, &kn, &ssen);
	fprintf(fp, HEAD46);
	fprintf(fp, CONT46, Step[I1], Step[I2], kn, ssen, xn0, yn0, rn);

	/* direction parameters */

	if ( !(Opt & IN_SITU_BIT) ){
		magcar(1., inc, dec, &x0, &y0, &z0);
		core(Azim[n], Plun[n], x0, y0, z0, &x, &y, &z);
		carmag(x, y, z, &dumm, &dumi, &dumd);
		if (Opt & ANCHOR_BIT){
			fprintf(fp, HEAD5g);
			fprintf(fp, CONT5g, nr, Step[I1], Step[I2], inc, dec, mad, dumi, dumd);
		}
		else {
			fprintf(fp, HEAD5);
			fprintf(fp, CONT5, nr, Step[I1], Step[I2], inc, dec, mad, theta, \
					devn, devl, dumi, dumd);
		}
	}
	else {
		magcar(1., inc, dec, &x0, &y0, &z0);
		coren(Azim[n], Plun[n], x0, y0, z0, &x, &y, &z);
		carmag(x, y, z, &dumm, &dumi, &dumd);
		if (Opt & ANCHOR_BIT){
			fprintf(fp, HEAD6g);
			fprintf(fp, CONT5g, nr, Step[I1], Step[I2], inc, dec, mad, dumi, dumd);
		}
		else {
			fprintf(fp, HEAD6);
			fprintf(fp, CONT5, nr, Step[I1], Step[I2], inc, dec, mad, theta, \
					devn, devl, dumi, dumd);
		}
	}

	fclose(fp);
	freevd(magdn);   freevd(incdn);   freevd(decdn);
	freevd(magdp);   freevd(incdp);   freevd(decdp);
	freevd(xn);   freevd(yn);
}
#undef EXT
#undef TITLE
#undef TITLEM
#undef HEAD1
#undef HEAD1M
#undef HEAD2
#undef HEAD2M
#undef HEAD3
#undef HEAD4
#undef HEAD4M
#undef HEAD4c
#undef HEAD4cM
#undef HEAD4z
#undef HEAD4zM
#undef HEAD45
#undef HEAD46
#undef HEAD5
#undef HEAD5g
#undef HEAD6
#undef HEAD6g
#undef CONT0
#undef CONT0g
#undef CONT0C
#undef CONT0gC
#undef CONT1
#undef CONT2
#undef CONT3
#undef CONT4
#undef CONT4c
#undef CONT4z
#undef CONT45
#undef CONT452
#undef CONT46
#undef CONT5
#undef CONT5g
