#include <math.h>
#include <string.h>
#include "pinte.h"

#define CONT	"%.4f %.4f\n"
#define CLBL	"%.4f %.4f 10p,Helvetica,black RB X\n%.4f %.4f 10p,Helvetica,black LB Y\n%.4f %.4f 10p,Helvetica,black RB Z\n"
#define CTCKX	"%.4f %.4f 10p,Helvetica,black BC %.0f\n"
#define CTCKXF	"%.4f %.4f 10p,Helvetica,black BC %.1f\n"
#define CTCKY	"%.4f %.4f 10p,Helvetica,black MR %.0f\n"
#define CTCKYF	"%.4f %.4f 10p,Helvetica,black MR %.1f\n"

extern char Buf[WBUF];
extern unsigned int Opt;
extern int Nstep, Nptr, Nmdtl, I1, I2;
extern double *Magn, *Magt, Xzn1, Xzn2, Yzn1, Yzn2, Yyr1, Yyr2, Yzr1, Yzr2, \
		Gapzn, dXzn, *Xzn, *Yzn, *Zzn, *Xzm, *Yzm, *Zzm, Xzt1, Xzt2, \
		Yzt1, Yzt2, Gapzt, dXzt, *Xzt, *Yzt, *Zzt, *Xzp, *Yzp, *Zzp;
static char Range[100], Remane[50], Stmp[200], In_situ[10];

/* pi_zjn -- plot Zijderveld diagram for NRM steps */

void pi_zjn()
{
	/* axis & tick */

	sprintf(Range, " -R%.2f/%.2f/%.2f/%.2f", Xzn1, Xzn2, Yzn1, Yzn2);
	sprintf(Buf, "%.2f 0\n%.2f 0\n", Xzn1, Xzn2);  wrt_tmp();
	sys_call(9, "gmt psxy ", FILET, MAPZ, Range, TICKZ, PEN2S, XYZN, " -P -O -K >>", FILEP);
	sprintf(Buf, "0 %.2f\n0 %.2f\n", Yzn1, Yzn2);  wrt_tmp();
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN2S, " -P -O -K >>", FILEP);
	sprintf(Stmp, CLBL, Xzn2 - Gapzn, -Gapzn, Gapzn, Yzn2 - Gapzn, -Gapzn, Yzn2 - Gapzn);
	sprintf(Buf, "%s", Stmp);  wrt_tmp();
	sys_call(7, "gmt pstext ", FILET, MAPZ, Range, OPTF, " -P -O -K >>", FILEP);
	if (Xzn1 < -dXzn) draw_tickx(-dXzn, Gapzn);
	if (Xzn2 > dXzn) draw_tickx(dXzn, Gapzn);
	if (Yzn1 < -dXzn) draw_ticky(-dXzn, Gapzn);
	if (Yzn2 > dXzn) draw_ticky(dXzn, Gapzn);

	/* plot MD pTRM tail check by dimmed solid & open triangles */

	if (Nmdtl > 0){
		wrt_tmp2(0, Nmdtl-1, CONT, Xzm, Yzm);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, TRIA3SG, " -P -O -K >>", FILEP);
		wrt_tmp2(0, Nmdtl-1, CONT, Xzm, Zzm);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, TRIA3OG, " -P -O -K >>", FILEP);
	}

	/* plot a regression line if applicable */

	if (Opt & REGRES_BIT || Opt & CIRCLE_BIT){
		sprintf(Buf, "%.4f %.4f\n%.4f %.4f\n", Xzn1, Yyr1, Xzn2, Yyr2);  wrt_tmp();
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3D, " -P -O -K >>", FILEP);
		sprintf(Buf, "%.4f %.4f\n%.4f %.4f\n", Xzn1, Yzr1, Xzn2, Yzr2);  wrt_tmp();
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3D, " -P -O -K >>", FILEP);
	}

	/* plot data */

	if (I1 > 0){
		wrt_tmp2(0, I1, CONT, Xzn, Yzn);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5SG, " -P -O -K >>", FILEP);
		wrt_tmp2(0, I1, CONT, Xzn, Zzn);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5OG, " -P -O -K >>", FILEP);
	}
	if (I2 < Nstep){
		wrt_tmp2(I2, Nstep-1, CONT, Xzn, Yzn);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5SG, " -P -O -K >>", FILEP);
		wrt_tmp2(I2, Nstep-1, CONT, Xzn, Zzn);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5OG, " -P -O -K >>", FILEP);
	}
	wrt_tmp2(I1, I2, CONT, Xzn, Yzn);
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3S, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5S, " -P -O -K >>", FILEP);
	wrt_tmp2(I1, I2, CONT, Xzn, Zzn);
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3D, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5O, " -P -O -K >>", FILEP);

	/* plot text */

	if ( !(Opt & IN_SITU_BIT) ) strcpy(In_situ, "CORE");
	else strcpy(In_situ, "IN SITU");
	sprintf(Remane, "%.2e", Magn[0]);
	sprintf(Buf, TEXTZ, "NRM", Remane, In_situ); wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPZT, OPTF, " -P -O -K >>", FILEP);
}

/* pi_zjt -- plot Zijderveld diagram for TRM steps with pTRM test */

void pi_zjt()
{
	int i1, i;

	/* axis & tick */

	sprintf(Range, " -R%.2f/%.2f/%.2f/%.2f", Xzt1, Xzt2, Yzt1, Yzt2);
	sprintf(Buf, "%.2f 0\n%.2f 0\n", Xzt1, Xzt2);  wrt_tmp();
	sys_call(9, "gmt psxy ", FILET, MAPZ, Range, TICKZ, PEN2S, XYZT, " -P -O -K >>", FILEP);
	sprintf(Buf, "0 %.2f\n0 %.2f\n", Yzt1, Yzt2);  wrt_tmp();
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN2S, " -P -O -K >>", FILEP);
	sprintf(Stmp, CLBL, Xzt2 - Gapzt, -Gapzt, Gapzt, Yzt2 - Gapzt, -Gapzt, Yzt2 - Gapzt);
	sprintf(Buf, "%s", Stmp);  wrt_tmp();
	sys_call(7, "gmt pstext ", FILET, MAPZ, Range, OPTF, " -P -O -K >>", FILEP);
	if (Xzt1 < -dXzt) draw_tickx(-dXzt, Gapzt);
	if (Xzt2 > dXzt) draw_tickx(dXzt, Gapzt);
	if (Yzt1 < -dXzt) draw_ticky(-dXzt, Gapzt);
	if (Yzt2 > dXzt) draw_ticky(dXzt, Gapzt);

	/* plot end point of vectors for pTRM test by dimmed solid & open triangles */

	if (Nptr > 0){
		wrt_tmp2(0, Nptr-1, CONT, Xzp, Yzp);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, TRIA3SG, " -P -O -K >>", FILEP);
		wrt_tmp2(0, Nptr-1, CONT, Xzp, Zzp);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, TRIA3OG, " -P -O -K >>", FILEP);
	}

	/* plot TRM data (0th data was omitted) */

	if (I1 == 0) i1 = 1;
	else i1 = I1;
	if (i1 > 1){
		wrt_tmp2(1, i1, CONT, Xzt, Yzt);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5SG, " -P -O -K >>", FILEP);
		wrt_tmp2(1, i1, CONT, Xzt, Zzt);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5OG, " -P -O -K >>", FILEP);
	}
	if (I2 < Nstep){
		wrt_tmp2(I2, Nstep-1, CONT, Xzt, Yzt);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5SG, " -P -O -K >>", FILEP);
		wrt_tmp2(I2, Nstep-1, CONT, Xzt, Zzt);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5OG, " -P -O -K >>", FILEP);
	}
	wrt_tmp2(i1, I2, CONT, Xzt, Yzt);
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3S, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5S, " -P -O -K >>", FILEP);
	wrt_tmp2(i1, I2, CONT, Xzt, Zzt);
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN3D, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, CIRC5O, " -P -O -K >>", FILEP);

	/* plot text */

	if ( !(Opt & IN_SITU_BIT) ) strcpy(In_situ, "CORE");
	else strcpy(In_situ, "IN SITU");
	sprintf(Remane, "%.2e", Magt[Nstep-1]);
	sprintf(Buf, TEXTZ, "TRM", Remane, In_situ);  wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPZT, OPTF, " -P -O -K >>", FILEP);
}

/* draw_tickx */

void draw_tickx(tick, gap)
double tick, gap;
{
	double tckln = 2.*gap, antln = 3.*gap;

	sprintf(Buf, "%.2f %.2f\n%.2f %.2f\n", tick, tckln, tick, -tckln);  wrt_tmp();
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN2S, " -P -O -K >>", FILEP);
	if (tick < 1. && tick > -1.){
		sprintf(Buf, CTCKXF, tick, -antln, tick);  wrt_tmp();
	}
	else {
		sprintf(Buf, CTCKX, tick, -antln, tick);  wrt_tmp();
	}
	sys_call(7, "gmt pstext ", FILET, MAPZ, Range, OPTF, " -P -O -K >>", FILEP);
}

/* draw_ticky */

void draw_ticky(tick, gap)
double tick, gap;
{
	double tckln = 2.*gap, antln = 3.*gap;

	sprintf(Buf, "%.2f %.2f\n%.2f %.2f\n", tckln, tick, -tckln, tick);  wrt_tmp();
	sys_call(7, "gmt psxy ", FILET, MAPZ, Range, PEN2S, " -P -O -K >>", FILEP);
	if (tick < 1. && tick > -1.){
		sprintf(Buf, CTCKYF, -antln, tick, tick);  wrt_tmp();
	}
	else {
		sprintf(Buf, CTCKY, -antln, tick, tick);  wrt_tmp();
	}
	sys_call(7, "gmt pstext ", FILET, MAPZ, Range, OPTF, " -P -O -K >>", FILEP);
}
#undef CONT
#undef CLBL
#undef CTCKX
#undef CTCKXF
#undef CTCKY
#undef CTCKYF
