#include "psvar.h"

#define MAPTXT	" -Jx1 -R-4.5/0/0/26"
#define XYT	" -X-6 -Y-13.5"
#define CNTF	"0.0 15.2 9p,Courier,black RB Im= %5.1f   Dm= %5.1f\n\
0.0 14.8 9p,Courier,black RB a95= %5.1f\n\
0.0 14.4 9p,Courier,black RB R=%6.3f    k=%6.1f\n\
0.0 14.0 9p,Courier,black RB S= %5.1f\n\
0.0 13.6 9p,Courier,black RB St= %5.1f   Sw= %5.1f\n"
#define CNTV	"0.0 4.4 9p,Courier,black RB N=    %2d   N0=    %2d\n\
0.0 4.0 9p,Courier,black RB Plat= %5.1f Plon= %5.1f\n\
0.0 3.6 9p,Courier,black RB A95= %5.1f\n\
0.0 3.2 9p,Courier,black RB R=%6.3f    k=%6.1f\n\
0.0 2.8 9p,Courier,black RB S = %5.1f   St= %5.1f\n\
0.0 2.4 9p,Courier,black RB Sw= %5.1f   Nw= %5.1f\n\
0.0 2.0 9p,Courier,black RB Slat= %5.1f Slon= %5.1f\n\
0.0 1.6 9p,Courier,black RB NPlat=%5.1f NPlon=%5.1f\n"
#define TITLE	"0.0 24.5 14p,Helvetica-Bold,black RB %s\n\
0.0 24.2 14p,Helvetica-Bold,black RT (See \"%s.PSV\" for details)\n"
#define NOTE	"0.0 1.2 8p,Courier,black RB (S is around %s)\n"
#define CNTWB	"0.0 0.8 8p,Courier,black RB L= %.4f (Nwb= %d)\n\
0.0 0.4 8p,Courier,black RB L95= %.4f  L975= %.4f\n\
0.0 0.0 8p,Courier,black RB (See \"%s.WB*\" for WB result)\n"

extern char Buf[WBUF], **Group;
extern unsigned int Opt;
extern int Nsite, Nm, Nwb;
extern double Im, Dm, Vtm, Vnm, A95m, A95vm, Rm, Rvm, Km, Kvm, Sltm, Slnm, \
	Nplt, Npln, Nwm, Swm, Swvm, Sb, Sbv, St, Stv, L0, L950, L975;

/* psv_text -- plot the result of statistics */

void psv_text(n)
int n;
{
	int i, j;

	sprintf(Buf, CNTV, Nm, Nsite, Vtm, Vnm, A95vm, Rvm, Kvm, \
		Sbv, Stv, Swvm, Nwm, Sltm, Slnm, Nplt, Npln);
	wrt_tmp();
	sys_call(7, "gmt pstext ", FILET, MAPTXT, OPTF, XYT, " -N -P -O -K >>", FILEP);
	sprintf(Buf, CNTF, Im, Dm, A95m, Rm, Km, Sb, St, Swm);
	wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPTXT, OPTF, " -N -P -O -K >>", FILEP);
	sprintf(Buf, TITLE, Group[n], Group[n]);   wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPTXT, OPTF, " -N -P -O -K >>", FILEP);
	if (Opt & WATSON_BERAN){
		sprintf(Buf, CNTWB, L0, Nwb, L950, L975, Group[n]);
		wrt_tmp();
		sys_call(6, "gmt pstext ", FILET, MAPTXT, OPTF, " -N -P -O -K >>", FILEP);
	}
	if ( !(Opt & ASD_NPOLE) )
		sprintf(Buf, NOTE, "MEAN");
	else
		sprintf(Buf, NOTE, "a FIXED NORTH POLE");
	wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPTXT, OPTF, " -N -P -O >>", FILEP);
}
#undef MAPTXT
#undef XYT
#undef CNTF
#undef CNTV
#undef TITLE
#undef NOTE
#undef CNTWB
