/* psvar.h -- header file for psvar modified from pstat.h */

#include "std.h"

/* general definitions, etc. */

#define FILEP	"PSVAR.PS"
#define FILET	"PSVAR.TMP"

#define WFILE	100	/* maximum length of data file name */
#define WGRP	50	/* maximum length of group name */
#define WSITE	50	/* maximum length of site name */
#define WBUF	1000	/* maximum length of Buf used by wrt_tmp */
#define NAMAX	64	/* maximum number of points to draw a95 */
#define ZERO	0

/* For use by unsigned int Opt */

#define SHOW_SITE	1
#define SHOW_DIST_SITE	2
#define PLOT_ALPH	4
#define PLOT_MEAN	8
#define PLOT_PATH	16
#define PLOT_SITEID	32
#define PLOT_NUMBER	64
#define SHOW_PRE_POST	128
#define FIX_HEMI	256
#define SOUTH_HEMI	512
#define ASD_NPOLE	1024
#define MAP_LONG	2048
#define WATSON_BERAN	4096
#define PLOT_STAMP	8192

/* GMT options */

#define PEN2S	" -W0.25p,black"
#define PEN2SR	" -W0.25p,red"
#define PEN2D	" -W0.25p,black,2_2:0"
#define PEN2DR	" -W0.25p,red,2_2:0"
#define PEN2SG	" -W0.25p,132"
#define PEN2DG	" -W0.25p,132,2_2:0"
#define PEN3S	" -W0.5p,black"
#define PEN3SR	" -W0.5p,red"
#define PEN3D	" -W0.5p,black,2_2:0"
#define PEN3DR	" -W0.5p,red,2_2:0"
#define PEN3SG	" -W0.5p,132"
#define PEN3DG	" -W0.5p,132,2_2:0"

#define CIRC2S	" -Sc0.2c -G0 -W0.25p,black"
#define CIRC2O	" -Sc0.2c -Gwhite -W0.25p,black"
#define CIRC3S	" -Sc0.3c -Gblack -W0.5p,black"
#define CIRC3SR	" -Sc0.3c -Gred -W0.5p,red"
#define CIRC3O	" -Sc0.3c -Gwhite -W0.5p,black"
#define CIRC3OR	" -Sc0.3c -Gwhite -W0.5p,red"
#define STAR3O	" -Sa0.3c -Gwhite -W0.5p,black"

#define GREY	" -G220"
#define OPTF	" -F+f+j"
#define DSHIFT4	" -D0.10/0.10"

/* Type of functions */

void quit_gv();
FILE *psv_cmd();
int psv_comd(), map_cutoff_lat(); void do_init(), go_next(), go_back(), go_first(), go_last(), \
	plot_locality(), map_longitude(), change_south_hemi(), alph_on_off(), plot_mean(), \
	plot_path(), delete_pre_post(), plot_id(), asd_north_pole(), do_WB(), num_iteration(), \
	out_psfile(), plot_stamp();
void psv_dat(), psv_grpdat(), psv_mem1(), psv_mem2(), free_all();
void psv_fld(); int psv_a95f();
void psv_plot(), wrt_tmp(), wrt_tmp2(), wrt_tmp3(), wrt_tmp3i(), wrt_tmp3c();
void psv_results();
void psv_statf(), set_one_site(), summ_data(), statf_result(), cal_delta(), cal_asd();
void psv_text();
void psv_vgp(); int psv_a95v(), psv_a95v2();
int psv_WB();
