#include <stdlib.h>
#include "std.h"

/* mallocvi -- memory allocation for an integer vector   100200
	Basic idea:
		this function does not do much.  it just allocate memory
		for a vector of usual C notation, a[0], ..., a[n-1],
		but useful to saves lines in programming.
	Example of usage:
		(at main program, declare as,)
			int *a, *mallocvi();
		(and allocate memory for 50 elements as,)
			a = mallocvi(50);
		(use normally in the main or call subprog as,)
			subprog(50, a, ...)
		(the subprog would look like as,)
			subprog(int n, int *vector, ...)
			  ...
			for(i = 0; i < n; i++)
				vector[i] = ...
		(to free memory use freevi(), which just pass to C's ordinary function, as,)
			freevi(a);
*/

int *mallocvi(n)
int n;
{
	int *x;

	x = (int *) malloc( (size_t)(n*sizeof(int)) );
	if (x == NULL) error("Error of malloc at mallocvi!");
	return(x);
}

/* mallocvd -- double vector version */

double *mallocvd(n)
int n;
{
	double *x;

	x = (double *) malloc( (size_t)(n*sizeof(double)) );
	if (x == NULL) error("Error of malloc at mallocvd!");
	return(x);
}

/*
char *mallocvs(n) -- NOT WORKABLE
int n;
{
	char *x;

	x = (char *) malloc((size_t)(n*sizeof(char)));
	if (x == NULL) error("Error of malloc at mallocvs!");
	return(x);
}
*/

/* freevi -- might seem useless, but can avoid to include stdlib.h in use */

void freevi(x)
int *x;
{
	free(x);
}

/* freevd */

void freevd(x)
double *x;
{
	free(x);
}
