/* std.h -- header file for stdlib library
	gaussfld4 added along the present gaussfld              11/17/24
	Updated gausscoeff & gaussfld                           4/2/20
	Bingham statistics statb & its relations included	8/31/19
	Larger version including porobability density funcs	9/1/18
	Small version for paleomagnetic programs		5/23/18
	Array memory is doubled					4/3/06
	PostScript materials were removed			8/6/96
	PostScript version for WorkStation JS5/85		8/26/95
	Simplified version for Macintosh			2/1/91
	To be used for C-compiler on MS-DOS			4/1/89
*/

#include <stdio.h>

#define GNMAX   10

#define NFILENAME	500
#define LSIZ_INP	500
#define LSIZ_GET	1000
#define LSIZ_COM	1000
#define TOKSIZ		100
#define NARG_INP	7
#define NARG_GET	16
#define ZERO		0

#define RAD	57.295779513
#define RT2	1.414213562
#define PAI	3.141592654
#define DPAI	6.283185307
#define HPAI	1.570796327
#define QPAI	0.785398163
#define LN2	0.693147181

int alph95();
double anglesd(), anglesd2(), confcoxu(), confcoxl(), asdr_f2p(), asdr_p2f();
void bedcor(), bedcorn();
double betai(), betacf();
double brent(); void mnbrak();
void carmag(), magcar(), carsph(), sphcar();
double chi2tab(), chi2dist(), chi2test(), chi2test2(); void f_Chi2();
int circreg(), circregk();
void core(), coren();
void decinc(), checklon();
double dpm(), adpm();
double fishtab(), fishcdist(), fishdist(), fishdense();
void fldadf(), vgpadf();
void fldvgp(), vgpfld(), vgpfld2(), fldadp(), fldvgp2();
FILE *fopenr(), *fopenw(), *fopena(); void rmfile();
double ftab(), fdist(); void f_F();
double gammln(), factrl(), bico(), factln(), beta();
double gammp(), gammq(), erfn(), erfnc(), erfcc(); void gser(), gcf();
int gausscoeff(); void gc_igrf13();
void gaussfld(), sumall(), gdtogc(), xzctoxzd();
void gaussfld4(), sumall4(), sumxadp4();
int getstr(), get_s(); void getoption();
void hista(), histd(), hist2c(), binboundc(), maxmin();
void histn(), histln(), histf(), countbin();
int inpi(), inpd();
int inpstr(), inps();
int jacobi(); void eigenorder();
void kstestn(), kstestf(), kstestl(), kstest2(); double probks();
double lgndr(), plgndr(), dlgndr(), mpsin();
void linregy(), linregby(), linregc();
int ludcmp(); void lubksb();
int **mallocmi(); double **mallocmd(); char **mallocms(); void freemi(), freemd(), freems();
int *mallocvi(); double *mallocvd(); void freevi(), freevd();
void meanvar(), meanvarl();
int mleb(); double mledk(), dk(); void mlebmap();
double normtab(), normcdist(), normdist(); void f_norm();
int pcagtc(), pcagtca();
int pcalin(), pcalina(); void check_usign();
int powell(); void linmin(); double f1dim();
double qsimp(), qtrap(), trapzd();
double quad2ds(), quad2ds1(), quad2ds2(), quad2ds3(), quad2ds4();
double ran1();
void ranf2(), ranh(); int ranb();
double rang(), gasdev();
void rotvec(), rotuvec(), rotveceu(), rotveceu2();
double rtsafe();
void sort(), sort2(), sort_r(), sort2_r();
int statb(); void chitest();
void statf(), statf2();
int stati(); double coth();
int stricmp(); void strucpy(), strlcpy();
double sundir(); void sunzl(), sunrd(), julid();
void sys_call(), str_cat();
double ttab(), tdist(); void f_t();
double vecmuls(), vecumuls(); void vecmulv(), vecumulv();
void vecsub(), vecadd(); double angdif();
double ymdtoy(); void ytoymd(), doytomd(), month_day();
int yorn(), get_ch(); void pause(), showless(), error();
